<?php
APBD_LoadCore("AppsBDKarnel","AppsBDKarnel",__FILE__);
class APBDLic extends AppsBDKarnel {
	function __construct( $pluginBaseFile, $version = '1.0.0' ) {
		//"APBLIC","Elite Licenser","1.0.0.13"
		$this->pluginFile       = $pluginBaseFile;
		$this->pluginBaseName   = 'APBLIC';
		$this->pluginName       = 'Elite Licenser';
		$this->pluginVersion    = $version;
		$this->bootstrapVersion = '4.6.0';
		parent::__construct( $pluginBaseFile, $version );
		
	}
	
	public function initialize() {
		parent::initialize();
		$this->SetIsLoadJqGrid(true);
		$this->SetPluginIconClass("abp abp-elite-licenser-o");
		$this->setSetActionPrefix("elite_licenser");
		
		$this->AddModule("APBDLicenseList");
		$this->AddModule("APBDClient");
		$this->AddModule("APBDProductList");
		$this->AddModule("APBDLicenseType");
		$this->AddModule("APBDProductLicense");
		$this->AddModule("APBDProductUpdate");
		$this->AddModule("APBDAPIKey");
		$this->AddModule("APBDRequestManage");
		$this->AddModule("APBDEmailTemplate");
		$this->AddModule("APBDLicIntegration");
		$this->AddModule("APBDBanHost");
		$this->AddModule("APBDDragDrop");
		$this->AddModule("APBDELAddons");
		$this->AddModule("APBDWebhook");
		$this->AddModule("APBDLicenseSettings");
	}

	function GetHeaderHtml() {
	
	}

	function GetFooterHtml() {
	
	}

	public function OnAdminAppStyles() {
		parent::OnAdminAppStyles();
		$this->AddAdminStyle("bootstrap-material-css","uilib/material/material.css",true);
	}
	public function OnAdminAppScripts() {
		parent::OnAdminAppScripts();
		//$this->AddAdminScript( "bootstrap-material-js", "uilib/bootstrap-material/js/material.min.js", true );


	}
	public function OnAdminGlobalStyles() {
		parent::OnAdminGlobalStyles();
		$currentScreen = get_current_screen();
		if(!empty($currentScreen->base) && $currentScreen->base=="dashboard"){
			$this->AddAdminStyle("elite-dashboard-css","dashboard.css");
		}
	}
	static function StartApp( $fileName ) {

	}
}