<?php
	/**
	 * @since: 11/04/2019
	 * @author: Sarwar Hasan
	 * @version 1.0.0
	 */
	
	class FastSpringIntegrator extends APBDLicIntegrator {
		function initialize() {
			$this->AddAjaxAction("view-details",[$this,'viewLicenseDetails']);
			$this->AddAjaxAction("add-link",[$this,'AddEnvatoProductLink']);
			$this->AddAjaxAction("save-api",[$this,'updateLicenseType']);
			$this->AddAjaxAction("get-envato-products",[$this,'getEnvatoProductsKeyValue']);
			$this->AddAjaxAction("get-linked-product",[$this,'getLinkedProductAjax']);
			$this->AddAjaxAction("get-license-type",[$this,'get_license_type']);
			$this->AddAjaxAction("delete-linked-item",[$this,'delete_linked_item']);
			Mapbd_license::RegisterMarkets("F","FastSpring");
			$this->title=' ';
   
		}
		function getTitleClass(){
			return 'fast-spring-int';
		}
		private function getAPIandProduct() {
			$products=Mapbd_product::FetchAllKeyValue("id","product_name");
			$productLicenseList=Mapbd_product_license::FetchAll();
			$licenses=Mapbd_license_type::FetchAllKeyValue("id","license_title",false,"product_id","ASC");
			$productLicenses=[];
			foreach ($productLicenseList    as $productLicense){
			    $productTitle=isset($products[$productLicense->product_id])?$products[$productLicense->product_id]:"Unknown Product";
			    $LicenseTypeTitle=isset($licenses[$productLicense->license_id])?$licenses[$productLicense->license_id]:"Unknown Product";
				$productLicenses["{$productLicense->product_id}-{$productLicense->license_id}"]="{$productTitle}-{$LicenseTypeTitle}";
            }
			$obj=new stdClass();
			$obj->apikeys=Mapbd_apikey::getActiveApiKeys();
			$obj->products=$productLicenses;
			return $obj;
		}
		public function OptionForm() {
			//echo $this->getViewPath();
			$this->AddViewData("fastInfo",$this->getAPIandProduct());
			$this->Display();
		}
		
	}