<?php
	/**
	 * @since: 16/11/2019
	 * @author: Sarwar Hasan
	 * @version 1.0.0
	 */
	
	class Mapbd_dropdown extends Mapbd_upload{
		private $uploadBasePath="";
		function AddFileLog($str,$isNew=false){
			if($isNew){
				//file_put_contents( WP_CONTENT_DIR . "/dd.log", $str . "\n" );
			}else {
				//file_put_contents( WP_CONTENT_DIR . "/dd.log", $str . "\n", FILE_APPEND );
			}
		}
		
		/**
		 * @param $zip_path
		 * @param $product_id
		 * @param $icon
		 * @param string $type
		 * @param string $hasOwnMenu
		 * @param  Mapbd_upload $responseObject
		 *
		 * @return bool
		 */
		function processLicensing($zip_path,$product_id,$icon,$type='F',$hasOwnMenu='Y',$instruction='',&$responseObject=null) {
			//$zip_path=$this->uploadBasePath.$zip_path;
			WP_Filesystem();
			global $wp_filesystem;
			$pathid = hash( 'crc32b', basename( $zip_path, ".zip" ) . time() );
			$dest   = $this->uploadBasePath . "products/$pathid/";
			$codePath = $dest . "code/";
			if ( ! is_dir( $codePath ) ) {
				wp_mkdir_p( $codePath);
				
			}
			
			$unzipfile = unzip_file( $zip_path, $codePath );
			if ( $unzipfile ) {
				
				//$this->AddFileLog( "--Searching Main File", true );
				$mainFile = $this->FindMainFile( $codePath );
				if ( $mainFile ) {
					$mainFile      = realpath( $mainFile );
					$mainFileData  =  APBD_file_get_contents( $mainFile );
					$isTheme       = substr( $mainFile, - 4 ) == ".css" && file_exists( dirname( $mainFile ) . "/functions.php" );
					$firstComment  = $this->getFirstComment( $mainFileData );
					$secondComment = "";
					$func_file     = realpath( $mainFile );
					if ( ! $isTheme ) {
						$secondComment = $this->getFirstComment( $mainFileData, true, true );
					} else {
						$func_file    = realpath( dirname( $mainFile ) . "/functions.php" );
						$mainFileData =  APBD_file_get_contents( dirname( $mainFile ) . "/functions.php" );
					}
					$mainFileData            = trim( $mainFileData );
					$mainFileData            = substr( $mainFileData, 0, 5 ) == '<?php' ? trim( substr( $mainFileData, 5 ) ) : $mainFileData;
					$mainFileData            = substr( $mainFileData, - 2 ) == '?>' ? substr( $mainFileData, 0, - 2 ) : $mainFileData;
					$realDest                = realpath( $dest );
					$realDestLength          = strlen( $realDest );
					$pluginData              = $this->getFileData( $mainFile, true );
					$pluginData['is_theme']  = $isTheme;
					$pluginData['main_file'] = $mainFile;
					$pluginData['func_path'] = str_replace( $realDest, "", dirname( $func_file ) . "/" );
					if($type=="F"){
						$iconPath=$realDest."/".$pluginData['func_path']."_el_icon/";
						if(!is_dir($iconPath)){
							wp_mkdir_p( $iconPath);
						}
						$iconFileDest=$iconPath.basename($icon);
						if(function_exists("pathinfo")){
							$path_parts=pathinfo($icon);
							if(!empty($path_parts['extension'])){
								$iconFileDest=$iconPath."_menu_icon.".$path_parts['extension'];
							}
						}
						
						if(!rename($icon,$iconFileDest)){
							$this->AddError("Icon moving failed");
							return false;
						}else{
							$icon=$iconFileDest;
						}
					}
					if ( file_exists( $dest . "/" . basename( $func_file ) ) ) {
						unlink( $dest . "/" . basename( $func_file ) );
					}
					if ( rename( $func_file, $dest . "/" . basename( $func_file ) ) ) {
						$func_file = realpath( $dest . "/" . basename( $func_file ) );
					}
					$commentFile =  $dest . "/comment.elite";
					$code_file   =  $dest . "/code.elite" ;
					$instruction_file   =  $dest . "/instruction.elite" ;
					
					file_put_contents( $commentFile, $firstComment . "\n" . $secondComment );
					
					file_put_contents( $code_file, $mainFileData );
					file_put_contents( $instruction_file, $instruction );
					
					$pluginData['func_file']      = $func_file;
					$pluginData['comment_file']   = realpath( $dest . "/comment.elite" );
					$pluginData['code_file']      = realpath( $dest . "/code.elite" );
					$pluginData['target_product'] = $product_id;
					$pluginData['icon_type']      = $type;
					$pluginData['icon']           = $icon;
					
					$nwUpload = new Mapbd_upload();
					$nwUpload->dir_id( $pathid );
					$nwUpload->name( $pluginData['Name'] );
					$nwUpload->version( $pluginData['Version'] );
					$nwUpload->author( $pluginData['Author'] );
					$nwUpload->textdomain( $pluginData['TextDomain'] );
					$nwUpload->is_theme( $pluginData['is_theme']?"Y":"N" );
					$nwUpload->main_file( substr( $pluginData['main_file'], $realDestLength ) );
					$nwUpload->func_file( substr( $pluginData['func_file'], $realDestLength ) );
					$nwUpload->target_product( $pluginData['target_product'] );
					$nwUpload->icon_type( $pluginData['icon_type'] );
					$nwUpload->icon( $pluginData['icon'] );
					$nwUpload->has_own_menu( $hasOwnMenu);
					if ( $nwUpload->Save() ) {
						unlink($zip_path);
						$responseObject=$nwUpload;
						return $this->PrepareOutputZip($nwUpload);
					}else{
						$this->AddError("Save failed, please try again later");
						return false;
					}
				}else{
					$this->AddError("It (".basename($zip_path).") doesn't a valid wordpress plugin or theme");
					//WP_Filesystem_Base::rmdir($dest,true);
					$wp_filesystem->delete($dest,true);
					return false;
				}
				
			} else {
				//$this->AddFileLog( "Error on unzipping" );
				$this->AddError("Wordpress can't unzip the uploaded file");
				return false;
			}
			
			//$this->PrepareOutputZip('48e73290');
		}
		
		function getFirstComment(&$mainFileData ,$isRemove=true,$fullSearch=false,$removeContent='') {
			$firstComment = "";
			$mainFileData = trim( $mainFileData );
			preg_match( '/^\/\*.*?\*\//ims', $mainFileData, $match );
			
			if ( ! empty( $match[0] ) ) {
				$firstComment = $match[0];
				if ( $isRemove || $fullSearch ) {
					$mainFileData = str_replace( $match[0], $removeContent, $mainFileData );
				}
				if ( ! empty( $firstComment ) && $fullSearch ) {
					$firstComment .="\n". $this->getFirstComment( $mainFileData ,$isRemove,$fullSearch);
				}
			}
			
			return $firstComment;
		}
		function FindMainFile($path,$lavel=1){
			
			//$this->AddFileLog("---".$path);
			$listFolder=[];
			foreach (glob($path.'*') as $fileOrFolder){
				
				if($fileOrFolder=="." || $fileOrFolder==".."){continue;}
				//$this->AddFileLog("---".str_repeat("-",$lavel).$fileOrFolder);
				if(is_dir($fileOrFolder)){
					if($lavel==1){
						$listFolder[]=$fileOrFolder."/";
					}else{
						continue;
					}
				}else{
					if($this->isMainFile($fileOrFolder)){
						
						return $fileOrFolder;
					}
				}
			}
			foreach ($listFolder as $fileOrFolder){
				$isFound=$this->FindMainFile($fileOrFolder,$lavel+1);
				if(!empty($isFound)){
					return $isFound;
				}
			}
			return null;
		}
		function getFileData($filePath,$isUnsetTheme=false){
			$default_headers = array(
				'Name'        => 'Plugin Name',
				'PluginURI'   => 'Plugin URI',
				'ThemeName'   => 'Theme Name',
				'ThemeURI'   => 'Theme URI',
				'Version'     => 'Version',
				'Description' => 'Description',
				'Author'      => 'Author',
				'AuthorURI'   => 'Author URI',
				'TextDomain'  => 'Text Domain',
				'DomainPath'  => 'Domain Path',
				// 'Network'     => 'Network',
				// Site Wide Only is deprecated in favor of Network.
				//'_sitewide'   => 'Site Wide Only',
			);
			$data=get_file_data( $filePath, $default_headers, 'plugin' );
			if(empty($data['Name']) && !empty($data['ThemeName'])){
				$data['Name']=$data['ThemeName'];
				$data['PluginURI']=$data['ThemeURI'];
				if($isUnsetTheme) {
					unset($data['ThemeName']);
					unset($data['ThemeURI']);
				}
			}
			return $data;
		}
		function isMainFile($filePath){
			$exten=substr($filePath,-4);
			$supportedstr=[".css",".php"];
			if(!in_array($exten,$supportedstr)){
				//$this->AddFileLog("--skipped");
				return false;
			}
			
			$pluginData = $this->getFileData($filePath);
			
			if((!empty($pluginData['Name']) || !empty($pluginData['ThemeName'])) && !empty($pluginData['Version'])){
				return true;
			}else{
				if(basename($filePath)=="style.css"){
					//$this->AddFileLog(print_r($pluginData,true));
				}
				//$this->AddFileLog($filePath);
				
				return false;
			}
			
			return false;
		}
		
		/**
		 * @param Mapbd_upload $jsonData
		 *
		 * @return bool
		 */
		function PrepareOutputZip($jsonData) {
			//$jsonData=Mapbd_upload::FindBy("id",$pathId);
			
			if ( ! empty( $jsonData ) ) {
				$basePath = $this->uploadBasePath . "products/{$jsonData->dir_id}";
				
				$product = Mapbd_product::FindBy( "id", $jsonData->target_product );
				if ( $product ) {
					$apiBase                   = APBDLicenseSettings::GetModuleInstance()->GetAPIUrl( "" );
					$productname_without_space = str_replace( " ", "", $product->product_name );
					$icon_or_file              = $jsonData->icon_type == "F" ? 'plugins_url("/_el_icon/' . basename( $jsonData->icon ) . '",__FILE__)' : '"' . $jsonData->icon . '"';
					if ( $jsonData->has_own_menu == "Y" ) {
						$activatedmaneu = '
	//add_menu_page (  "' . $productname_without_space . '", "' . $product->product_name . '", "activate_plugins", $this->slug, [$this,"activated"], ' . $icon_or_file . ');
	add_submenu_page(  $this->slug, "' . $productname_without_space . ' License", "License Info", "activate_plugins",  $this->slug."_license", [$this,"activated"] );
	';
					} else {
						$activatedmaneu = '
	add_menu_page (  "' . $productname_without_space . '", "' . $product->product_name . '", "activate_plugins", $this->slug, [$this,"activated"], ' . $icon_or_file . ');
	//add_submenu_page(  $this->slug, "' . $productname_without_space . ' License", "License Info", "activate_plugins",  $this->slug."_license", [$this,"activated"] );
	';
					}
					$instructionHtml = "";
					if ( file_exists( $basePath . "/instruction.elite" ) ) {
						$instructionHtml =  APBD_file_get_contents( $basePath . "/instruction.elite" );
					}
					$base_class_name="C" . strtoupper( hash( "crc32b", $product->product_base . "Base" . $product->product_name ));
					$base_class_name=APBDScriptGeneratorWordPress::camel_case_to_snake_case($base_class_name,true);
					$replace_str_arr                 = [
						"lic_form_header"                  => $instructionHtml,
						"productname"                      => $product->product_name,
						"productname_without_space"        => $productname_without_space,
						"product_class_name_without_space" => $productname_without_space . "_M" . strtoupper( hash( "crc32b", $product->product_base . "Base" . $product->product_name ) ),
						"baseclassname"                    => $base_class_name,
						"basefilename"                     => "class-".strtolower(str_replace("_","-",$base_class_name)),
						"encryptedkey"                     => $product->enc_key,
						"productid"                        => $product->id,
						"productbase"                      => $product->product_base,
						"hostserver"                       => $apiBase . APBDLicenseSettings::GetModuleInstance()->GetOption( "api_end_point", "licensor" ) . "/",
						"hascheckupdate"                   => 'true',
						"isencyptupdate"                   => $product->is_enc_up_res == "Y" ? 'true' : 'false',
						"icon_or_file"                     => $icon_or_file,
						"themestylecss"                    => basename( $jsonData->main_file ),
						"ptproperties"                     =>  APBD_file_get_contents( $basePath . "/comment.elite" ),
						"activatedmenu"                    => $activatedmaneu,
						"source_version"                    => $jsonData->version
					
					];
					$replace_str_arr2                = [];
					$replace_str_arr2['requirelink'] = 'require_once "' . $replace_str_arr['baseclassname'] . '.php";';
					
					$replace_str_arr3                = [];
					$replace_str_arr3['requirelink'] = '';
					
					
					$baseRawFilePath = plugin_dir_path( APBDLicenseSettings::GetModuleInstance()->pluginFile ) . "/sample_script/wp/base.app";
					if ( $jsonData->is_theme == "Y" ) {
						$pluginOrThemeFile = plugin_dir_path( APBDLicenseSettings::GetModuleInstance()->pluginFile ) . "/sample_script/wp/theme/functions.app";
					} else {
						$pluginOrThemeFile = plugin_dir_path( APBDLicenseSettings::GetModuleInstance()->pluginFile ) . "/sample_script/wp/fullplugin.app";
					}
					$licCssFile =  APBD_file_get_contents( plugin_dir_path( APBDLicenseSettings::GetModuleInstance()->pluginFile ) . "/sample_script/wp/style.css" );
					$this->ReplaceString( $replace_str_arr, $licCssFile );
					
					$baseFileContent =  APBD_file_get_contents( $baseRawFilePath );
					
					$this->ReplaceString( $replace_str_arr, $baseFileContent );
					
					$dirpath         = realpath( dirname( $basePath . $jsonData->main_file ) ) . "/";
					$codeReletiveDir = str_replace( realpath( $basePath . "/code/" ), '', $dirpath );
					$codeDir         = $basePath . "/raw_codes" . $codeReletiveDir;
					$encCodeDir      = $basePath . "/enc_codes" . $codeReletiveDir;
					$this->AddFileLog( $codeDir );
					$this->AddFileLog( $encCodeDir );
					
					if ( ! is_dir( $codeDir ) ) {
						wp_mkdir_p( $codeDir );
					}
					if ( ! is_dir( $encCodeDir ) ) {
						wp_mkdir_p( $encCodeDir );
					}
					
					if ( file_put_contents( $codeDir . $replace_str_arr['baseclassname'] . '.php', $baseFileContent ) ) {
						
						$pluginOrThemeFileContent =  APBD_file_get_contents( $pluginOrThemeFile );
						$this->ReplaceString( $replace_str_arr, $pluginOrThemeFileContent );
						$contentforEncrypted = $pluginOrThemeFileContent;
						$this->ReplaceString( $replace_str_arr2, $pluginOrThemeFileContent );
						$this->ReplaceString( $replace_str_arr3, $contentforEncrypted );
						
						$this->getFirstComment( $pluginOrThemeFileContent, true, false, $replace_str_arr['ptproperties'] );
						$this->getFirstComment( $contentforEncrypted, true, true, '' );
						
						$codeFileContent          =  APBD_file_get_contents( $basePath . "/code.elite" );
						$codeFileContent          = str_replace( "\n", "\n\t\t\t", $codeFileContent );
						
						$hasCustomClass="";
						if(preg_match('#class #i',$codeFileContent)){
							$hasCustomClass="DM".strtoupper(hash('crc32b',$codeFileContent)).".php";
							if(!file_put_contents( $codeDir .$hasCustomClass, "<?php \n".$codeFileContent )){
								$hasCustomClass="";
							}else{
								$classContent = new Obfuscator( $codeFileContent . "?>\n" . $contentforEncrypted, 'Loading file...' );
								file_put_contents( $encCodeDir . $hasCustomClass, '<?php ' . "\r\n" . $classContent );
								$codeFileContent='include_once "'.$hasCustomClass.'";';
							}
						}
					
						$pluginOrThemeFileContent = str_replace( '//***Write you plugin\'s code here***', "\n\t\t\t" . $codeFileContent . "\n", $pluginOrThemeFileContent );
						
						
						if ( file_put_contents( $codeDir . basename( $jsonData->func_file ), $pluginOrThemeFileContent ) ) {
							$sObfusationData = new Obfuscator( $baseFileContent . "?>\n" . $contentforEncrypted, 'Loading file...' );
							file_put_contents( $encCodeDir . $replace_str_arr['baseclassname'] . '.php', '<?php ' . "\r\n" . $sObfusationData );
							if($jsonData->is_theme){
								file_put_contents( $encCodeDir . basename( $jsonData->func_file ), "<?php \n" ."\n\n require_once \"" . $replace_str_arr['baseclassname'] . ".php\";\n " );
							}else{
								file_put_contents( $encCodeDir . basename( $jsonData->func_file ), "<?php \n" . $replace_str_arr['ptproperties'] . "\n\n require_once \"" . $replace_str_arr['baseclassname'] . ".php\";\n " );
							}
							
							
							if ( file_put_contents( $dirpath . "_lic_style.css", $licCssFile ) ) {
								return true;
							} else {
								$this->AddError( "can't write css file to directory, may be permission denied" );
							}
						} else {
							$this->AddError( "can't write main file to directory, may be permission denied" );
						}
					} else {
						$this->AddError( "Can't write base file to directory, may be permission denied" );
					}
				} else {
					$this->AddError( "Invalid product information" );
				}
				//$this->makeZip($pathId);
			} else {
				$this->AddError( "DB data error" );
			}
			
			return false;
			
		}
		function makeZip($pathId='',$isEncrypted=false){
			$z = new ZipArchive();
			$outZipPath=realpath($this->uploadBasePath."products/{$pathId}/");
			if(!$isEncrypted) {
				if ( file_exists( $outZipPath . "/output.zip" ) ) {
					unlink( $outZipPath . "/output.zip" );
				}
			}else{
				if ( file_exists( $outZipPath . "/encrypted.zip" ) ) {
					unlink( $outZipPath . "/encrypted.zip" );
				}
			}
			if(!$isEncrypted) {
				if ( $z->open( $outZipPath . "/output.zip", ZIPARCHIVE::CREATE ) ) {
					$path_of_code=realpath( $outZipPath . "/code/" );
					$path_of_raw_code=realpath( $outZipPath . "/raw_codes/");
					self::folderToZip( realpath( $path_of_code ), $z, strlen( $path_of_code.DIRECTORY_SEPARATOR ) );
					self::folderToZip( realpath( $path_of_raw_code ), $z, strlen( $path_of_raw_code.DIRECTORY_SEPARATOR ) );
					$z->close();
				}
				if ( file_exists( $outZipPath . "/output.zip" ) ) {
					return true;
				}
			}else{
				if ( $z->open( $outZipPath . "/encrypted.zip", ZIPARCHIVE::CREATE ) ) {
					$path_of_code=realpath( $outZipPath . "/code/" );
					$path_of_en_code=realpath( realpath( $outZipPath . "/enc_codes/" ) );
					self::folderToZip( $path_of_code, $z, strlen( $path_of_code ) );
					self::folderToZip( $path_of_en_code, $z, strlen( $path_of_en_code ));
					$z->close();
				}
				if ( file_exists( $outZipPath . "/encrypted.zip" ) ) {
					return true;
				}
			}
			return false;
		}
		
		/**
		 * The folderToZip is generated by appsbd
		 *
		 * @param mixed $folder
		 * @param ZipArchive $zipFile
		 * @param mixed $exclusiveLength
		 */
		private static function folderToZip($folder, &$zipFile, $exclusiveLength) {
			$handle = opendir($folder);
			while (false !== $f = readdir($handle)) {
				if ($f != '.' && $f != '..') {
					$filePath = "$folder".DIRECTORY_SEPARATOR."$f";
					$filePath=realpath($filePath);
					// Remove prefix from file path before add to zip.
					$localPath = trim(substr($filePath, $exclusiveLength));
					if (is_file($filePath)) {
						$zipFile->addFile($filePath, $localPath);
					} elseif (is_dir($filePath)) {
						// Add sub-directory.
						$zipFile->addEmptyDir($localPath);
						self::folderToZip($filePath, $zipFile, $exclusiveLength);
					}
				}
			}
			closedir($handle);
		}
		static function zipData($source, $destination) {
			if (extension_loaded('zip') === true) {
				if (true || file_exists($source) === true) {
					$zip = new ZipArchive();
					
					if ($zip->open($destination, ZIPARCHIVE::CREATE) === true) {
						$source = realpath($source);
						
						if (is_dir($source) === true) {
							$files = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($source), RecursiveIteratorIterator::SELF_FIRST);
							
							foreach ($files as $file) {
								$file = realpath($file);
								
								if (is_dir($file) === true) {
									$zip->addEmptyDir(str_replace($source . DIRECTORY_SEPARATOR, '', $file .  DIRECTORY_SEPARATOR));
								} else if (is_file($file) === true) {
									$zip->addFromString(str_replace($source . DIRECTORY_SEPARATOR, '', $file), file_get_contents($file));
								}
							}
						} else if (is_file($source) === true) {
							$zip->addFromString(basename($source), file_get_contents($source));
						}
					}
					return $zip->close();
				}
			}
			return false;
		}
		function ReplaceString(&$replace_str_arr,&$stringD){
			foreach ($replace_str_arr as $key=>$sv){
				$stringD=str_replace("<<{$key}>>",$sv,$stringD);
			}
		}
		
		/**
		 * @param string $uploadBasePath
		 */
		public function setUploadBasePath( $uploadBasePath ) {
			$this->uploadBasePath = $uploadBasePath;
		}
	}