<?php
//Elite Licenser
class APBDClient extends AppsBDBaseModule{
    
      
	    
	   function initialize() {
            parent::initialize();
            $this->disableDefaultForm();
            $this->AddAjaxAction("add",[$this,"add"]);
            $this->AddAjaxAction("edit",[$this,"edit"]);
            $this->AddAjaxAction("delete_item",[$this,"delete_item"]);             
            
			$this->AddAjaxAction("status_change",[$this,"status_change"]);
	   }
    
        function OptionForm() {
            $this->SetTitle("Clients");
    	    
            $this->Display();
        }
        
        function GetMenuTitle() {
            return $this->__( "Clients" );
        }
        
        function GetMenuSubTitle() {
            return $this->__( "View all Clients" );
        }
        
        function GetMenuIcon() {
            return "ap ap-client-2";
        } 
       
       function add(){
            $this->SetTitle("Add Client");
            $this->SetPOPUPColClass ( "col-sm-8" );
           
            if(APPSBD_IsPostBack){
                $nobject=new Mapbd_client();
                if($nobject->SetFromPostData(true)){
                    if($nobject->Save()){
                        $this->AddInfo("Successfully added");
                        APBD_AddLog("A",$nobject->settedPropertyforLog(),"l001","");
                        $this->DisplayPOPUPMsg();
                        return;
                    }
                }
            }
            $mainObj=new Mapbd_client();
            //$this->SetPopupFromMutipart();     
            $this->AddViewData("isUpdateMode",false);
            $this->AddViewData("mainobj",$mainObj);
            $this->DisplayPOPUp("add");
	    }	    
       function edit($param_id=""){
           
           $param_id=APBD_GetValue("id");
           if(empty($param_id)){
                $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }           
            $this->SetTitle("Edit APBDClient");
            if(APPSBD_IsPostBack){
                    $uobject=new Mapbd_client();
                    if($uobject->SetFromPostData(false)){
                        $uobject->SetWhereUpdate("id",$param_id);
                        if($uobject->Update()){
                            APBD_AddLog("U",$uobject->settedPropertyforLog(),"l002","");
                            $this->AddInfo("Successfully updated");
                            $this->DisplayPOPUPMsg();
                            return;
                        }
                    }
            }
            $mainobj=new Mapbd_client();
            $mainobj->id($param_id);
            if(!$mainobj->Select()){
	            $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }
	       APBD_OldFields($mainobj, "name,email,country,company,entry_time,status");
            //$this->SetPopupFromMutipart();
            $this->AddViewData("mainobj", $mainobj);
            $this->AddViewData("isUpdateMode", true);           
            $this->DisplayPOPUP("add");
       } 
       public function OnInit() {
	       parent::OnInit(); // TODO: Change the autogenerated stub
       }
	
	function data(){
	        $mainResponse = new AppsbdAjaxDataResponse();
		     $mainResponse->setDownloadFileName("apbd-client-list");
        	$mainobj=new Mapbd_client();	  
        	$mainResponse->setDateRange($mainobj);  
            $records=$mainobj->CountALL($mainResponse->srcItem, $mainResponse->srcText,$mainResponse->multiparam,"both");
        	if($records>0){
        		$mainResponse->SetGridRecords($records);
        		//$mainResponse->setOrderByIfEmpty("id","DESC");
        	    //wp_apbd_client:id,name,email,country,company,entry_time,status		
        		$result=$mainobj->SelectAllGridData("", $mainResponse->orderBy, $mainResponse->order, $mainResponse->rows, $mainResponse->limitStart, $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam,"both");
        		if($result){
          
					$status_change=$mainobj->GetPropertyOptionsTag("status");
           
        			foreach ($result as &$data){
        				$data->action="";
        				$data->action.="<a data-effect='mfp-move-from-top' class='popupformWR btn btn-info btn-xs' href='" .$this->GetActionUrl("edit",["id"=>$data->id])."'>".$this->__("Edit")."</a>";
        			    $data->action.=" <a class='ConfirmAjaxWR btn btn-danger btn-xs' data-msg='".$this->__("If you delete this client (%s) then all license of the client will be delete too. Are you sure to delete?",$data->name)."' href='" .$this->GetActionUrl("delete_item",["id"=>$data->id])."'>".$this->__("Delete")."</a>";
        			   
						$data->status=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("status_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->status,$status_change)."</a>";
				
				        $data->action  =  apply_filters($this->getHookActionStr("client-list-action-button"),$data->action,$data,$this);
				        $data=apply_filters($this->getHookActionStr("client-list-row-data"),$data);
				
			        }
        		}
        		$mainResponse->SetGridData($result);
    		}
    		$mainResponse->DisplayGridResponse();	    
	   }
    
	           
	    function delete_item(){
		    $param=APBD_GetValue("id");
	        $mainResponse = new AppsbdAjaxConfirmResponse();
            if(empty($param)){
                 $mainResponse->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }           
            $mr=new Mapbd_client();           
            $mr->id($param);
            if($mr->Select()){
                //$ur=new Mapbd_client();
                if(Mapbd_client::DeleteByID($param)){
                    APBD_AddLog("D","id={$param}", "l003","APBDClient_confirm");
                    $mainResponse->DisplayWithResponse(true, __("Successfully deleted"));
                }else{
                    $mainResponse->DisplayWithResponse(false,__("Delete failed try again"));
                }
            }
        }
        
        function status_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->SetConfirmResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_client();  
            $statusChange=$mr->GetPropertyOptionsTag("status");
		         
            $mr->id($param);
            if($mr->Select("status")){
                $newStatus=$mr->status=="A"?"I":"A";
                $uo=new Mapbd_client();
                $uo->status($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->status, $statusChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDClient");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }
                
       
       
    
}