<?php
//Elite Licenser
class APBDProductLicense extends AppsBDBaseModule{
    
      
	    
	   function initialize() {
            parent::initialize();
            $this->disableDefaultForm();
            $this->AddAjaxAction("add",[$this,"add"]);
            $this->AddAjaxAction("edit",[$this,"edit"]);
            $this->AddAjaxAction("delete_item",[$this,"delete_item"]);             
            
			$this->AddAjaxAction("status_change",[$this,"status_change"]);
        }
    
        function OptionForm() {
            $this->SetTitle("Product Licenses");
    	    
            $this->Display();
        }
        
        function GetMenuTitle() {
            return $this->__( "Product Licenses" );
        }
        
        function GetMenuSubTitle() {
            return $this->__( "View all APBDProductLicense" );
        }
        
        function GetMenuIcon() {
            return "ap ap-product-license";
        } 
       
       function add(){
            $this->SetTitle("Add product with license ");
            $this->SetPOPUPColClass ( "col-sm-6" );
           
            if(APPSBD_IsPostBack){
                $nobject=new Mapbd_product_license();
                if($nobject->SetFromPostData(true)){
                    if($nobject->Save()){
                        $this->AddInfo("Successfully added");
                        APBD_AddLog("A",$nobject->settedPropertyforLog(),"l001","");
                        $this->DisplayPOPUPMsg();
                        return;
                    }
                }
            }
            $mainobj=new Mapbd_product_license();
            //$this->SetPopupFromMutipart();     
            $this->AddViewData("isUpdateMode",false);
            $this->AddViewData("mainobj",$mainobj);
            $this->DisplayPOPUp("add");
	    }	    
       function edit($param_id=""){
            $this->SetPOPUPColClass ( "col-sm-6" );
           
           $param_id=APBD_GetValue("id");
           if(empty($param_id)){
                 $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }           
            $this->SetTitle("Edit product with license");
	       $mainobj=new Mapbd_product_license();
	       $mainobj->id($param_id);
	       if(!$mainobj->Select()){
		       $this->AddError("Invalid request");
		       $this->DisplayPOPUPMsg();
		       return;
	       }
            if(APPSBD_IsPostBack){
                    $uobject=new Mapbd_product_license();
                    if($uobject->SetFromPostData(false)){
                        $uobject->SetWhereUpdate("id",$param_id);
                        $uobject->UnsetAllExcepts('license_id,status');
                        $isOk=true;
                        if($uobject->IsSetPrperty("license_id")){
	                        if(Mapbd_product_license::CheckIsExistsLicense($mainobj->product_id,$uobject->license_id)){
		                        $isOk=false;
		                        $this->AddError("License type has been already exists on this product");
	                        }
                        }
                       
                        if($isOk && $uobject->Update()){
                            APBD_AddLog("U",$uobject->settedPropertyforLog(),"l002","");
                            $this->AddInfo("Successfully updated");
                            $this->DisplayPOPUPMsg();
                            return;
                        }
                    }
            }
            
            APBD_OldFields($mainobj, "license_id,status");
            //$this->SetPopupFromMutipart();
            $this->AddViewData("mainobj", $mainobj);
            $this->AddViewData("isUpdateMode", true);           
            $this->DisplayPOPUP("add");
       } 
       
	   
	   function data(){	 
	        $mainResponse = new AppsbdAjaxDataResponse();   		
    		$mainResponse->setDownloadFileName("apbd-product-license-list");
        	$mainobj=new Mapbd_product_license();	  
        	$mainResponse->setDateRange($mainobj);  
            $records=$mainobj->CountALL($mainResponse->srcItem, $mainResponse->srcText,$mainResponse->multiparam,"after");
        	if($records>0){
        		$mainResponse->SetGridRecords($records);
        		//$mainResponse->setOrderByIfEmpty("id","DESC");
        	    //wp_apbd_product_license:id,product_id,license_id,status		
        		$result=$mainobj->SelectAllGridData("", $mainResponse->orderBy, $mainResponse->order, $mainResponse->rows, $mainResponse->limitStart, $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam,"after");
        		if($result){            	     
            	    $products=Mapbd_product::FetchAllKeyValue("id","product_name");
            	    $licneseTypes=Mapbd_license_type::FetchAllKeyValue("id","license_title");
					$status_change=$mainobj->GetPropertyOptionsTag("status");
            	                	    
        			foreach ($result as &$data){
        				$data->action="";
        				$data->action.="<a data-effect='mfp-move-from-top' class='popupformWR btn btn-info btn-xs' href='" .$this->GetActionUrl("edit",["id"=>$data->id])."'>".$this->__("Edit")."</a>";
        			    $data->action.=" <a class='ConfirmAjaxWR btn btn-danger btn-xs' data-on-complete='APBD_product_license_reload' data-msg='".$this->__("Are you sure to delete?")."' href='" .$this->GetActionUrl("delete_item",["id"=>$data->id])."'>".$this->__("Delete")."</a>";
        			    $pid=' <span class="text-success">( ID:'.$data->product_id.')</span>';
        			    $lid=' <span class="text-success">( ID:'.$data->license_id.')</span>';
        			    $data->product_id=APBD_getTextByKey($data->product_id,$products).$pid;
        			    $data->license_id=APBD_getTextByKey($data->license_id,$licneseTypes).$lid;
						$data->status=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("status_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->status,$status_change)."</a>";
				
				        $data->action  =  apply_filters($this->getHookActionStr("product-license-type-list-action-button"),$data->action,$data,$this);
				        $data=apply_filters($this->getHookActionStr("product-license-list-row-data"),$data);
				
			        }
        		}
        		$mainResponse->SetGridData($result);
    		}
    		$mainResponse->DisplayGridResponse();	    
	   }
    
	           
	    function delete_item($param=""){
	        $mainResponse = new AppsbdAjaxConfirmResponse();
		    $param=APBD_GetValue("id");
            if(empty($param)){
                 $mainResponse->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }           
            $mr=new Mapbd_product_license();           
            $mr->id($param);
            if($mr->Select()){
                //$ur=new Mapbd_product_license();
                if(Mapbd_product_license::DeleteByID($param)){
                    APBD_AddLog("D","id={$param}", "l003","APBDProductLicense_confirm");
                    $mainResponse->DisplayWithResponse(true, __("Successfully deleted"));
                }else{
                    $mainResponse->DisplayWithResponse(false,__("Delete failed try again"));
                }
            }
        }
        
        function status_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_product_license();  
            $statusChange=$mr->GetPropertyOptionsTag("status");
		         
            $mr->id($param);
            if($mr->Select("status")){
                $newStatus=$mr->status=="A"?"I":"A";
                $uo=new Mapbd_product_license();
                $uo->status($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->status, $statusChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDProductLicense");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }
                
       
       
    
}