<?php
	/** @var APBDELAddons $this */
	 $addons=$this->GetAddonList();
?>
<div class="row">
    <div class="col-sm-12 ">
        <div class="card document-card">
            <div class="card-header">
				<?php $this->_e($this->GetMenuTitle()) ;
					
					if(!empty($addons) && is_array($addons)) {
				?>
                <small class="float-sm-right text-warning text-bold">
                    <i class="fa fa-exclamation-triangle faa-pulse animated"></i> <?php $this->_e("Do not install nulled version addons. That can be harmfull for your main licenser app") ; ?>
                </small>
                <?php } ?>
            </div>
            <div class="card-body p-3">
               
                <div class="pl-3">
	            <div class="row">
             
	            <?php
	                if(!empty($addons) && is_array($addons)) {
		                foreach ( $addons as $addon ) {
			                //  print_r($addon);
			                ?>
                            <div class="col-sm-4 pl-0 mb-3">
                                <div class="card addon-box p-3">
                                    <div class="card-body ">
                                        <h4 class="card-title"><?php echo $addon->addon_name; ?></h4>
                                        <p class="card-text addon-description text-justify"><?php echo $addon->description; ?></p>
                                        <div class="pt-3 d-flex justify-content-between align-items-center">
							                <?php if ( $addon->is_activated ) {
								                ?>
                                                <a data-on-complete="ChangePluginStatus"
                                                   href="<?php echo esc_url( $this->GetActionUrl( "active-plugin", [ "p" => $addon->addon_path ] ) ); ?>"
                                                   data-msg="<?php $this->_e( "Are you sure?" ); ?>"
                                                   class="ConfirmAjaxWR btn btn-sm btn-danger"><i
                                                            class="fa fa-ban"></i> <?php $this->_e( "Deactivate" ); ?>
                                                </a>
								                <?php
							                } elseif ( $addon->is_installed ) {
								                ?>
                                                <a data-on-complete="ChangePluginStatus"
                                                   href="<?php echo esc_url( $this->GetActionUrl( "active-plugin", [ "p" => $addon->addon_path ] ) ); ?>"
                                                   data-msg="<?php $this->_e( "Are you sure?" ); ?>"
                                                   class="btn btn-sm btn-success ConfirmAjaxWR"><i
                                                            class="fa fa-check-circle-o"></i> <?php $this->_e( "Active" ); ?>
                                                </a>
								                <?php
							                } else { ?>
                                                <a target="_blank" href="<?php echo esc_url( $addon->install_button ); ?>"
                                                   class="btn btn-sm btn-success"><i
                                                            class="fa fa-external-link"></i> <?php $this->_e( "Install" ); ?>
                                                </a>
                                               
							                <?php } ?>
                                            <a target="_blank" href="<?php echo esc_url( $addon->plugin_url ); ?>"
                                               class="btn btn-sm btn-info"><i
                                                        class="fa fa-external-link"></i> <?php $this->_e( "View Details" ); ?>
                                            </a>
                                        </div>
                                    </div>
                                </div>
                            </div>
			                <?php
		                }
	                }else{
	                    ?>
                        <div class="w-100 text-danger text-bold text-center"><?php $this->_e("No addon found right now") ; ?></div>
		                <?php
                    }
	                ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<script type="application/javascript">
    function ChangePluginStatus(rdata, element){
        if (typeof(swal) == "function") {
            swal(rdata.status ? "Success" : "Failed", rdata.msg, rdata.status ? "success" : "error");
        } else {
            APPSBDAPPJS.notification.ShowGritterMsg(rdata.msg, rdata.status, rdata.is_sticky, rdata.title, rdata.icon);
        }
        if (rdata.status) {
            element.removeClass(rdata.data.removeClass);
            element.addClass(rdata.data.addClass);
            element.html(rdata.data.text);
            setTimeout(function () {
                try {
                    APPSBDAPPJS.core.ReloadSiteUrl();
                }catch (e) {}
            },1000);
        }
    }
</script>