<?php
/** @var APBDLicenseList $this
 *  @var Mapbd_license $mainObj;
 *  @var Mapbd_useddomain [] $domains;
 */
?>

<div class="clearfix form pb-3">
    <div class="row">
        <div class="col-sm">
            <div class="card apsbd-default-card">
                <div class="card-header"><?php $this->_e("License Code"); ?> : <?php echo $mainObj->purchase_key;	?></div>
                <div class="card-body p-0 max-h-400 o-auto">
                    <table class="table m-0">
                        <thead>
                        <tr>
                            <th class="wd-20">#</th>
                            <th ><?php $this->_e("Domain") ?></th>
                            <th class="text-center" width="230px" ><?php $this->_e("Added Time") ?></th>
                            <th class="text-center"  width="80px" ><?php $this->_e("Version") ?></th>
                            <th class="text-center"  width="80px" ><?php $this->_e("Status") ?></th>
                            <th class="text-center"  width="120px" ><?php $this->_e("Action") ?></th>
                        </tr>
                        </thead>
                        <tbody>
		                <?php
			                $r=1;
			                foreach ( $domains as $domain ) {
				                $domain= APBD_CastClass("Mapbd_useddomain", $domain);
				                ?>
                                <tr>
                                    <td><?php echo $r++; ?></td>
                                    <td><a class="mr-2" href="<?php echo $domain->full_domain; ?>" target="_blank"> <i class="fa fa-external-link"></i> </a> <?php echo $domain->full_domain; ?></td>
                                    <td class="text-center" ><?php echo APBD_getWPDateTimeWithFormat($domain->entry_time); ?></td>
                                    <td class="text-center" ><?php echo $domain->version; ?></td>
                                    <td  class="text-center status-container" ><?php echo $domain->getTextByKey("status"); ?></td>
                                    <td class="text-center" >
                                        <div class="btn-group" role="group">
                                            <?php if($domain->status=="W"){ ?>
                                            <a href="<?php echo $this->GetActionUrl("accept_domain",["id"=>$domain->id]);?>" data-on-complete="OnDomainAccept" data-msg="<?php $this->_e("Are you sure to accept?") ; ?>" class="ConfirmAjaxWR btn btn-success btn-sm"><i class="fa fa-check"></i>  <?php $this->_e("Accept") ?></a>
                                            <?php } ?>
                                            <a href="<?php echo $this->GetActionUrl("delete_domain",["id"=>$domain->id]);?>" data-on-complete="OnDomainRemove" data-msg="<?php $this->_e("Are you sure to remove?") ; ?>" class="ConfirmAjaxWR btn btn-danger btn-sm"> <i class="fa fa-trash"></i> <?php $this->_e("Remove") ?></a>
                                            
                                        </div>
                                        
                                    </td>
                                </tr>
				                <?php
			                }
		                ?>
                        </tbody>
                    </table>
                </div>
            </div>
            
          
        </div>
        

    </div>


</div>
<div class="btn-group-md popup-footer text-right">
    <button type="button" class="close-pop-up btn btn-sm  btn-danger"><i class="fa fa-times"></i> <?php $this->_e("Close"); ?></button>
</div>
<script type="text/javascript">
    function OnDomainRemove(rdata,elem){
        if(rdata.status) {
            elem.closest('tr').remove();
            
        }
        APPSBDAPPJS.notification.ShowResponseSwal(rdata);
    }
    function OnDomainAccept(rdata,elem){
        if(rdata.status) {
            //elem.closest('tr').remove();
            elem.closest('tr').find(".status-container").html(rdata.data.status_txt);
            elem.remove();
        }
        APPSBDAPPJS.notification.ShowResponseSwal(rdata);
    }
</script>