<?php	/** @var EnvatoIntegrator $this */
?>
<div class="card mb-3">
    <div class="card-body p-3">
        <p><?php $this->_e("If you pick API Based Method, it is not necessary to use the Product Webhook method. API-based reduced the hassle to add a webhook URL for each product in the paddle.") ; ?></p>
        <p><?php $this->_e("Remember to keep enabling the New license-created email from the Elite Licenser email template setting page, or your customer will miss out the a license in their email.");?></p>
    </div>
</div>

<form class="apbd-module-form"  role="form" id="main-form" data-on-complete="paddleSaveApinfo"   action="<?php echo $this->GetActionUrl(""); ?>" method="post">
    <div class="card mb-3">
        <div class="card-header pt-0 pb-0">
            <div class="row">
                <div class="col">
                    <div class="form-group">
                        <label class="col-form-label" for="status"><?php $this->_ee("Enable Paddle API"); ?>
			                <?php
				                APBD_GetHTMLSwitchButtonInline("paddle_api_status","paddle_api_status","I","A",$this->GetOption("paddle_api_status",'I'),false,'has_depend_fld');
			                ?>
                        </label>
                    </div>
                </div>
                <div class="col">
                
                </div>
            </div>
           
        </div>
    </div>
</form>
    <div class="accordion apbd-accrodion fld-paddle-api-status fld-paddle-api-status-a" id="paddle-api-accordion">
        <div class="card">
            <div class="card-header p-0" id="config_header">

                <button class="btn text-bold btn-block text-left" type="button" data-toggle="collapse" data-target="#paddle-config" aria-expanded="true" aria-controls="paddle-config">
                    1. <?php $this->_e("Configuration"); ?>
                </button>

            </div>

            <div id="paddle-config" class="collapse p-2" aria-labelledby="config_header" data-parent="#paddle-api-accordion">
                <form class="apbd-module-form"  role="form" id="<?php echo $this->GetMainFormId();?>" data-on-complete="paddleSaveApinfo"   action="<?php echo $this->GetActionUrl(""); ?>" method="post">
                <div class="card">
                    <div class="card-body p-2">
                        <div class="row">
                            <div class="col-8">
                                <div class="form-group row ">
                                    <label class="col-form-label col-sm-4" for="status"><?php $this->_ee("Test Mode"); ?></label>
                                    <div class="col-sm">
										<?php
											APBD_GetHTMLSwitchButton("paddle_api_test_mode","paddle_api_test_mode","N","Y",$this->GetOption("paddle_api_test_mode",'N'),false,'has_depend_fld');
										?>
                                    </div>
                                </div>
                                <div class="fld-paddle-api-test-mode <?php echo $this->GetOption("paddle_api_test_mode",'N')=='Y'?' d-none ':''; ?> fld-paddle-api-test-mode-n">
                                    <div class="form-group row">
                                        <label for="paddle_api_vendor_id" class="col-sm-4 col-form-label"><?php $this->_e("Vendor ID") ; ?></label>
                                        <div class="col-sm">
                                            <input type="text" class="form-control" name="paddle_vendor_id" value="<?php echo $this->GetOption("paddle_vendor_id"); ?>" id="paddle_api_vendor_id">
                                        </div>
                                    </div>
                                    <div class="form-group row">
                                        <label for="paddle_api_Key" class="col-sm-4 col-form-label"><?php $this->_e("Paddle API Key") ; ?></label>
                                        <div class="col-sm">
                                            <input type="text" class="form-control" value="<?php echo $this->GetOption("paddle_api_Key"); ?>" name="paddle_api_Key" id="paddle_api_Key">
                                        </div>
                                    </div>
                                </div>
                                <div class="fld-paddle-api-test-mode fld-paddle-api-test-mode-y <?php echo $this->GetOption("paddle_api_test_mode",'N')=='N'?' d-none ':''; ?>">

                                    <div class="form-group row">
                                        <label for="paddle_test_api_vendor_id" class="col-sm-4 col-form-label"><?php $this->_e("Vendor ID") ; ?></label>
                                        <div class="col-sm">
                                            <input type="text" class="form-control" name="paddle_test_vendor_id" value="<?php echo $this->GetOption("paddle_test_vendor_id"); ?>" id="paddle_test_api_vendor_id">
                                        </div>
                                    </div>
                                    <div class="form-group row">
                                        <label for="paddle_test_api_Key" class="col-sm-4 col-form-label"><?php $this->_e("Paddle API Key") ; ?></label>
                                        <div class="col-sm">
                                            <input type="text" class="form-control" value="<?php echo $this->GetOption("paddle_test_api_Key"); ?>" name="paddle_test_api_Key" id="paddle_test_api_Key">
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-4">
                                <p><?php $this->_e("Or auto connect by click on the button below: ") ; ?></p>
                                <button id="connect-with-paddle" class="btn btn-sm btn-info"><?php $this->_e("Connect with paddle") ; ?></button>
                            </div>
                        </div>

                    </div>
                    <div class="card-footer">
                        <button id="api_form_submit_btn" class="btn btn-success btn-sm" type="submit"><?php $this->_e("Save") ; ?></button>
                    </div>
                </div>
                </form>
            </div>
        </div>
        <div class="card">
            <div class="card-header p-0" id="paddle_map_prd">

                <button class="text-bold btn btn-block text-left collapsed" type="button" data-toggle="collapse" data-target="#linked_product_ctnr" aria-expanded="false" aria-controls="linked_product_ctnr">
                    2. <?php $this->_e("Linked With Paddle Product") ; ?>
                </button>

            </div>
            <div id="linked_product_ctnr" class="collapse p-2" aria-labelledby="paddle_map_prd" data-parent="#paddle-api-accordion">
                <div class="d-sm-flex justify-content-between align-items-center">
                    <button id="paddle-reload-product" class="btn btn-info btn-xs"><?php $this->_e("Reload Product") ; ?></button>
                    <a href="<?php echo $this->GetActionUrl('add-link') ;?>" class="popupformWR btn btn-info btn-xs"><?php $this->_e("Add New Link") ; ?></a>
                </div>
                <div class="card mt-2 ">

                    <div   class="card-body">
                        <table class="table table-sm m-0">
                            <thead class="thead-dark">
                            <tr>
                                <th class="text-center" width="5%;" scope="col">#</th>
                                <th width="35%"  scope="col"><?php $this->_e("Paddle Product") ; ?></th>
                                <th width="5%" scope="col">&nbsp;</th>
                                <th  width="35%;" scope="col"><?php $this->_e("App Product & License") ?></th>
                                <th width="10%" class="text-center" scope="col"><?php $this->_e("Delete"); ?></th>
                            </tr>
                            </thead>
                            <tbody id="paddle-link-pd-ctnr-bd">

                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
   



<script type="application/javascript">
    'use strict';
	<?php
	$params=http_build_query(array(
		'app_name' => get_bloginfo('name').'- Elite Licenser',
		'app_description' => 'Paddle Payment Gateway. connect with : '.get_bloginfo('name').'- Elite Licenser',
		'app_icon' => plugins_url('images/logo54px.png', $this->pluginFile)
	));
	$PaddleConnectorUrl="https://vendors.paddle.com/vendor/external/integrate?". $params;
	$PaddleConnectorSandboxUrl="https://sandbox-vendors.paddle.com/vendor/external/integrate?". $params;
	?>

    function paddle_connector() {
        window.open("<?php echo $PaddleConnectorUrl; ?>", 'Paddle Connect', 'location=no,status=0,scrollbars=0,width=800,height=600');
        // handle message sent from popup
        window.addEventListener('message', function (e) {
            console.log(e);
            console.log(e.data);
            try {
                if (e.origin == "https://vendors.paddle.com") {
                    var arrData = e.data.split(" ");
                    jQuery('#paddle_api_vendor_id').val(arrData[0]).trigger("input");
                    jQuery('#paddle_api_Key').val(arrData[1]).trigger("input");
                    jQuery('#api_form_submit_btn').click();
                }
            } catch (e) {

            }
        });
    }
    function paddle_linked_product(){

        jQuery.ajax({
            url: "<?php echo $this->GetActionUrl('get-links') ?>",
            method: "GET",
            beforeSend:function(){
                jQuery("#linked_product_ctnr").addClass("form-loader");
            },
            success: function(product_html){
                $("#paddle-link-pd-ctnr-bd").html(product_html);
                APPSBDAPPJS.Initialize();
            },
            complete:function(){
                jQuery("#linked_product_ctnr").removeClass("form-loader");
            }
        });
    }
    window.PaddlelinkedDelete=function(rdata){
        if (typeof(swal) == "function") {
            swal(rdata.status ? "Success" : "Failed", rdata.msg, rdata.status ? "success" : "error");
        } else {
            notification.ShowGritterMsg(rdata.msg, rdata.status, rdata.is_sticky, rdata.title, rdata.icon);
        }
        if (rdata.status) {
            paddle_linked_product();
        }

    }
    window.paddleSaveApinfo=function(rdata,form){
        var form_id=form.closest('.apbd-module-container').attr("id");
        APPSBDAPPJS.core.CallOnModuleAjaxSuccess(form_id,rdata,form);
        paddle_linked_product();
    }
    function paddle_sandbox_connector(){
        window.open("<?php echo $PaddleConnectorSandboxUrl; ?>", 'Paddle Connect', 'location=no,status=0,scrollbars=0,width=800,height=600');
        // handle message sent from popup
        window.addEventListener('message', function(e) {

            //console.log(e.data);
            console.log(e);;
            var arrData = e.data.split(" ");
            console.log(arrData);
            jQuery('#paddle_test_api_vendor_id').val(arrData[0]).trigger("input");
            jQuery('#paddle_test_api_Key').val(arrData[1]).trigger("input");
        });
    }



    function isTestMode(){
        return $("input[name=paddle_api_test_mode]:checked").is(":checked");
    }
    jQuery( document ).ready(function( $ ) {
        jQuery("#paddle_api_status").on("change",function (e){
            var v= $(this).is(":checked")?'A':'I';
            var thisobj=$(this);
           APPSBDAPPJS.core.CallMyAjax("<?php echo $this->GetActionUrl(""); ?>",{paddle_api_status:v},function(){
               thisobj.prop('disabled',true);
           },function(rdata){
               if(!rdata.status){
                   APPSBDAPPJS.notification.ShowGritterMsg(rdata.msg,rdata.status,rdata.isSticky,rdata.title,rdata.icon);
               }
           },true,function(){
               thisobj.prop('disabled',false);
           });
        });
        jQuery("#paddle-reload-product").on("click",paddle_linked_product);
        jQuery("#connect-with-paddle").on("click",function(e){
            e.preventDefault();
            if(isTestMode()){
                paddle_sandbox_connector();
            }else{
                paddle_connector();
            }
        });
        paddle_linked_product();
        APPSBDAPPJS.core.AddOnCloseLightboxWithEvent("<?php echo $this->GetReloadEvent(); ?>",paddle_linked_product);
    });

</script>