<?php
	/** @var APBDLicIntegration $this */
?>
<div class="card apsbd-default-card">
    <div class="card-header pt-0 pb-0 pl-0">
        <div class="row">
           
            <div class="col">
                <ul class="app-card-tab nav justify-content nav-tabs" id="IntegrationTab" role="tablist" >
                    <?php if(count(APBDLicIntegration::$markets)>0){
	                    $totalInt=0;
	                    foreach ( APBDLicIntegration::$markets as $mkey=>$market ) {
		                    $totalInt++;
                            ?>
                            <li class="nav-item ">
                                <a class="nav-link <?php echo $totalInt===1?"active show":""; ?> <?php echo $market->getTitleClass(); ?> "  data-toggle="tab" id="#mktb_<?php echo $mkey; ?>" href="#mkt_<?php echo $mkey; ?>" >
                                    <i class="<?php echo $market->getIcon(); ?>"></i>
				                    <?php $this->_e($market->getTitle()); ?>
                                </a>
                            </li>
                            <?php
                        }
                    } ?>
                </ul>
            </div>
            <div class="p-2 p-sm-3 d-none d-sm-block text-right pull-right title-in-xs">
                <i class="apd-mod-icon <?php echo $this->GetMenuIcon(); ?>"></i>
		        <?php echo $this->GetMenuTitle(); ?>
            </div>
            
        </div>
       
       
    </div>
    <div class="card-body p-3 grid-body min-height-335 " >
        <div class="tab-content" id="IntegrationTabContent">
	        <?php
                if(count(APBDLicIntegration::$markets)>0){
	                $totalInt=0;
		        foreach ( APBDLicIntegration::$markets as $mkey=>$market ) {
			        $totalInt++;
			        ?>
                    <div class="tab-pane fade  <?php echo $totalInt===1?"active show":""; ?>" id="mkt_<?php echo $mkey; ?>" role="tabpanel" aria-labelledby="mkt_<?php echo $mkey; ?>-tab">
                       <?php $market->OptionForm(); ?>
                    </div>
			        <?php
		        }
	        } ?>
           
            <div class="tab-pane fade" id="apbd_lic_jvzoo" role="tabpanel" aria-labelledby="apbd_lic_jvzoo-tab">
                <div class="form-group">
                    <label for="exampleInputEmail1">Email address</label>
                    <input type="email" class="form-control" id="exampleInputEmail1" aria-describedby="emailHelp" placeholder="Enter email">
                    <small id="emailHelp" class="form-text text-muted">We'll never share your email with anyone else.</small>
                </div>
            </div>
            
        </div>
    </div>
</div>

<script type="text/javascript">

</script>