<?php
/**
 * Plugin Name: Elite Licenser
 * Plugin URI: http://elitelicenser.com
 * Description: It's a plugin for any types of product licensing, it is handle with care your products licensing
 * Version: 2.4.0
 * Author: 20script
 * Author URI: http://www.20script.ir
 * Text Domain: APBLIC
 * Tested up to: 6.0
 */


global $wpdb;
require_once 'core/helper.php';
require_once 'appcore/APBDLic.php';
if ( version_compare( PHP_VERSION, '8.3', '<' ) ) {
	if ( class_exists( 'APBDLic' ) ) {
		$applic = new APBDLic( __FILE__, '2.4.0' );
		

		$applic->StartPlugin();
	}
} else {
	add_action(
		'init',
		function () {
			add_action(
				'admin_print_styles',
				function() {
					if ( ! empty( $_GET['page'] ) && $_GET['page'] == 'APBLIC' ) {
						wp_register_style( 'boostrap', plugins_url( 'uilib/boostrap/4.6.0/appsbdbootstrap.css', __FILE__ ) );
						wp_enqueue_style( 'boostrap' );
					}
					wp_register_style( 'el-font', plugins_url( 'uilib/product-icon/icon.css', __FILE__ ) );
					wp_enqueue_style( 'el-font' );
					wp_register_style( 'all-el', plugins_url( 'css/all-css.css', __FILE__ ) );
					wp_enqueue_style( 'all-el' );

				}
			);

		}
	);
	add_action(
		'admin_menu',
		function() {
			add_menu_page(
				'Elite Licenser',
				'Elite Licenser',
				'activate_plugins',
				'APBLIC',
				function () {
					?>
			<div id="APPSBDWP">
				<div class="container-fluid">
					<div class="card col-12 p-0">
						<div class="card-header">
							<h2>
									<i class="abp abp-elite-licenser"></i> <?php _e( 'Elite Licenser', 'APBLIC' ); ?>
							</h2>
						</div>
						<div class="card-body">
								<?php printf( __( "Elite Licenser doesn't support PHP version %1\$s, we will add support of this version as soon as possible, please use bellow %2\$s for now", 'APBLIC' ), PHP_VERSION, '8.1.0' ); ?>
						</div>
						
					</div>
				</div>
				
			</div>
			
					<?php
				},
				'dashicons-elite-licensor'
			);
		}
	);
}


