<?php
	/**
	 * @since: 23/04/2019
	 * @author: Sarwar Hasan
	 * @version 1.0.0
	 */
	abstract  class  APBDScriptGeneratorBase {
		public $name;
		public $icon;
		public $isActive=false;
		public $tempPath="";
		protected static $selfobjec=[];
		protected $pluginFile;
		
		protected function __construct() {
		
		}
		static function &getInstance(){
			if(!isset(self::$selfobjec[static::class])){
				self::$selfobjec[static::class]=new static();
			}
			return self::$selfobjec[static::class];
		}
		function setPluginPath($file) {
			$this->pluginFile = $file;
		}
		function setTmpPath($path){
			$this->tempPath=$path;
			if(!is_dir($this->tempPath)){
				mkdir($this->tempPath,0755,true);
			}
		}
		public static function camel_case_to_snake_case($str,$disable_lower_case=false)
		{
			$str=preg_replace('/(?<!^)[A-Z]/', '_$0', $str);
			if($disable_lower_case){
				return $str;
			}
			return strtolower($str);
		}
		/**
		 * @param $product_id; product id
		 *
		 * @return mixed
		 */
		abstract  function outputZip($product_id,$params=[]);
		
	}