<?php 			
/** 
 * @since: 08/Mar/2019
 * @author: Sarwar Hasan 
 * @version 1.0.0
 * @property:another_section,changelog,description,download_link,id,last_update,new_version,plugin_name,requires,slug,status,tested		
 */						
class Mapbd_updateinfo extends AppsBDModel{	
	public $another_section;
	public $changelog;
	public $description;
	public $download_link;
	public $id;
	public $last_update;
	public $new_version;
	public $plugin_name;
	public $requires;
	public $slug;
	public $status;
	public $tested;


	    /**
	     *@property another_section,changelog,description,download_link,id,last_update,new_version,plugin_name,requires,slug,status,tested
		 */
		function __construct() {
			parent::__construct ();
			$this->SetValidation();	
			$this->tableName="apbd_updateinfo";
			$this->primaryKey="id";
			$this->uniqueKey=array();	
			$this->multiKey=array(array("slug"));
			$this->autoIncField=array("id");	
			$this->app_base_name="APBLIC";

		}
			

	function SetValidation(){
		$this->validations=array(
			//"another_section"=>array("Text"=>"Another Section", "Rule"=>""),
			//"changelog"=>array("Text"=>"Changelog", "Rule"=>""),
			//"description"=>array("Text"=>"Description", "Rule"=>""),
			"download_link"=>array("Text"=>"Download Link", "Rule"=>"xss_clean|required|max_length[100]"),
			"id"=>array("Text"=>"Id", "Rule"=>"max_length[11]|integer"),
			"last_update"=>array("Text"=>"Last Update", "Rule"=>"xss_clean|max_length[20]"),
			"new_version"=>array("Text"=>"New Version", "Rule"=>"xss_clean|required|max_length[8]"),
			"plugin_name"=>array("Text"=>"Plugin Name", "Rule"=>"xss_clean|required|max_length[50]"),
			"requires"=>array("Text"=>"Requires", "Rule"=>"xss_clean|required|max_length[8]"),
			"slug"=>array("Text"=>"Slug", "Rule"=>"xss_clean|required|max_length[8]"),
			"status"=>array("Text"=>"Status", "Rule"=>"xss_clean|max_length[1]"),
			"tested"=>array("Text"=>"Tested", "Rule"=>"xss_clean|required|max_length[8]")
			
		);
	}

    /*
	public function GetPropertyRawOptions($property,$isWithSelect=false){
	    $returnObj=array();
		switch ($property) {
	      default:
	    }	        	   
        if($isWithSelect){
            return array_merge(array(""=>"Select"),$returnObj);
        }
        return $returnObj;
		
	}  
    */
	   

    /*
	public function GetPropertyOptionsColor($property){
	    $returnObj=array();
		switch ($property) {
	      default:
	    }       
        return $returnObj;
	
	}
    */
	   

    /*
	public function GetPropertyOptionsIcon($property){
	    $returnObj=array();
		switch ($property) {
	      default:
	    }
        return $returnObj;
	
	}
    */
	   		
	    	
	//auto generated
    /*function Save(){			   
	    return parent::Save();
	}*/
			

	 static function CreateDBTable(){
		$thisObj=new static();
		$table=$thisObj->db->prefix.$thisObj->tableName;			
		if($thisObj->db->get_var("show tables like '{$table}'") != $table){
			$sql = "CREATE TABLE `{$table}` (
					  `id` int(11) NOT NULL AUTO_INCREMENT,
					  `slug` char(8) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
					  `plugin_name` char(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
					  `new_version` char(8) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
					  `requires` char(8) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
					  `tested` char(8) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '',
					  `last_update` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
					  `download_link` char(100) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
					  `description` tinytext CHARACTER SET utf8 COLLATE utf8_general_ci,
					  `another_section` tinytext CHARACTER SET utf8 COLLATE utf8_general_ci,
					  `changelog` tinytext CHARACTER SET utf8 COLLATE utf8_general_ci,
					  `status` char(1) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'I' COMMENT 'A=Active,I=Inactive',
					  PRIMARY KEY (`id`) USING BTREE,
					  KEY `slug` (`slug`) USING BTREE
					) ";				 
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
			dbDelta($sql);
		}
	 }
	 function DropDBTable(){
		global $wpdb;
		$table=$wpdb->prefix.$this->tableName;
		$table_name = $wpdb->prefix . $this->tableName;
		$sql        = "DROP TABLE IF EXISTS $table_name;";
		$wpdb->query( $sql );
	 }
/* add custom function here*/
	
/* end custom function */
	 function GetAddForm($label_col=5,$input_col=7,$mainobj=null,$except=array(),$disabled=array()){
		
				if(!$mainobj){
				$mainobj=$this;
				}
					?>
			<div class="form-row">
			<?php if(!in_array("another_section",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="another_section"><?php $this->_ee("Another Section"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength=""   value="<?php echo  $mainobj->GetPostValue("another_section");?>" id="another_section" <?php echo in_array("another_section", $disabled)?' disabled="disabled" ':' name="another_section" ';?>     placeholder="<?php $this->_ee("Another Section");?>" >
			     				      	
		      </div> 
		     <?php } ?>
			</div>
			<div class="form-row">
			<?php if(!in_array("changelog",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="changelog"><?php $this->_ee("Changelog"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength=""   value="<?php echo  $mainobj->GetPostValue("changelog");?>" id="changelog" <?php echo in_array("changelog", $disabled)?' disabled="disabled" ':' name="changelog" ';?>     placeholder="<?php $this->_ee("Changelog");?>" >
			     				      	
		      </div> 
		     <?php } ?>
			
			<?php if(!in_array("description",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="description"><?php $this->_ee("Description"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength=""   value="<?php echo  $mainobj->GetPostValue("description");?>" id="description" <?php echo in_array("description", $disabled)?' disabled="disabled" ':' name="description" ';?>     placeholder="<?php $this->_ee("Description");?>" >
			     				      	
		      </div> 
		     <?php } ?>
			</div>
			<div class="form-row">
			<?php if(!in_array("download_link",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="download_link"><?php $this->_ee("Download Link"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="100"   value="<?php echo  $mainobj->GetPostValue("download_link");?>" id="download_link" <?php echo in_array("download_link", $disabled)?' disabled="disabled" ':' name="download_link" ';?>     placeholder="<?php $this->_ee("Download Link");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Download Link");?>">
			     				      	
		      </div> 
		     <?php } ?>
			
			</div>
			<div class="form-row">
			<?php if(!in_array("last_update",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="last_update"><?php $this->_ee("Last Update"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="20"   value="<?php echo  $mainobj->GetPostValue("last_update");?>" id="last_update" <?php echo in_array("last_update", $disabled)?' disabled="disabled" ':' name="last_update" ';?>     placeholder="<?php $this->_ee("Last Update");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Last Update");?>">
			     				      	
		      </div> 
		     <?php } ?>
			
			<?php if(!in_array("new_version",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="new_version"><?php $this->_ee("New Version"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="8"   value="<?php echo  $mainobj->GetPostValue("new_version");?>" id="new_version" <?php echo in_array("new_version", $disabled)?' disabled="disabled" ':' name="new_version" ';?>     placeholder="<?php $this->_ee("New Version");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","New Version");?>">
			     				      	
		      </div> 
		     <?php } ?>
			</div>
			<div class="form-row">
			<?php if(!in_array("plugin_name",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="plugin_name"><?php $this->_ee("Plugin Name"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="50"   value="<?php echo  $mainobj->GetPostValue("plugin_name");?>" id="plugin_name" <?php echo in_array("plugin_name", $disabled)?' disabled="disabled" ':' name="plugin_name" ';?>     placeholder="<?php $this->_ee("Plugin Name");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Plugin Name");?>">
			     				      	
		      </div> 
		     <?php } ?>
			
			<?php if(!in_array("requires",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="requires"><?php $this->_ee("Requires"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="8"   value="<?php echo  $mainobj->GetPostValue("requires");?>" id="requires" <?php echo in_array("requires", $disabled)?' disabled="disabled" ':' name="requires" ';?>     placeholder="<?php $this->_ee("Requires");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Requires");?>">
			     				      	
		      </div> 
		     <?php } ?>
			</div>
			<div class="form-row">
			<?php if(!in_array("slug",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="slug"><?php $this->_ee("Slug"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="8"   value="<?php echo  $mainobj->GetPostValue("slug");?>" id="slug" <?php echo in_array("slug", $disabled)?' disabled="disabled" ':' name="slug" ';?>     placeholder="<?php $this->_ee("Slug");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Slug");?>">
			     				      	
		      </div> 
		     <?php } ?>
			
			<?php if(!in_array("status",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="status"><?php $this->_ee("Status"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="1"   value="<?php echo  $mainobj->GetPostValue("status");?>" id="status" <?php echo in_array("status", $disabled)?' disabled="disabled" ':' name="status" ';?>     placeholder="<?php $this->_ee("Status");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Status");?>">
			     				      	
		      </div> 
		     <?php } ?>
			</div>
			<div class="form-row">
			<?php if(!in_array("tested",$except)){ ?>
			 <div class="form-group col-sm">
		      	<label class="col-form-label" for="tested"><?php $this->_ee("Tested"); ?></label>
		      	 <input  class="form-control form-control-sm" type="text" maxlength="8"   value="<?php echo  $mainobj->GetPostValue("tested");?>" id="tested" <?php echo in_array("tested", $disabled)?' disabled="disabled" ':' name="tested" ';?>     placeholder="<?php $this->_ee("Tested");?>" data-bv-notempty="true" 	data-bv-notempty-message="<?php   $this->_ee("%s is required","Tested");?>">
			     				      	
		      </div> 
		     <?php } ?>
			
			</div>
			<?php 
	}


}
?>