<?php
//Elite Licenser
class APBDAPIKey extends AppsBDBaseModule{
	    
	   function initialize() {
            parent::initialize();
            $this->disableDefaultForm();
            $this->AddAjaxAction("add",[$this,"add"]);
            $this->AddAjaxAction("edit",[$this,"edit"]);
            $this->AddAjaxAction("delete_item",[$this,"delete_item"]);             
            
			$this->AddAjaxAction("add_product_change",[$this,"add_product_change"]);
			$this->AddAjaxAction("edit_product_change",[$this,"edit_product_change"]);
			$this->AddAjaxAction("view_product_change",[$this,"view_product_change"]);
			$this->AddAjaxAction("add_client_change",[$this,"add_client_change"]);
			$this->AddAjaxAction("edit_client_change",[$this,"edit_client_change"]);
			$this->AddAjaxAction("view_client_change",[$this,"view_client_change"]);
			$this->AddAjaxAction("add_license_change",[$this,"add_license_change"]);
			$this->AddAjaxAction("edit_license_change",[$this,"edit_license_change"]);
			$this->AddAjaxAction("view_license_change",[$this,"view_license_change"]);
			$this->AddAjaxAction("status_change",[$this,"status_change"]);
			
        }
    
        function OptionForm() {
            $this->SetTitle("API List");
    	    
            $this->Display();
        }
        
        function GetMenuTitle() {
            return $this->__( "API List" );
        }
        
        function GetMenuSubTitle() {
            return $this->__( "View all API list" );
        }
        
        function GetMenuIcon() {
            return "ap ap-api-list";
        } 
       
       function add(){
            $this->SetTitle("Add API Key ");
            $this->SetPOPUPColClass ( "col-sm-8" );
            if(APPSBD_IsPostBack){
                $nobject=new Mapbd_apikey();
                if($nobject->SetFromPostData(true)){
                    if($nobject->Save()){
                        $this->AddInfo("Successfully added");
                        APBD_AddLog("A",$nobject->settedPropertyforLog(),"l001","");
                        $this->DisplayPOPUPMsg();
                        return;
                    }
                }
            }
            $mainobj=new Mapbd_apikey();
            //$this->SetPopupFromMutipart();     
            $this->AddViewData("isUpdateMode",false);
            $this->AddViewData("mainobj",$mainobj);
            $this->DisplayPOPUp("add");
	    }	    
       function edit($param_id=""){
            $this->SetPOPUPColClass ( "col-sm-8" );
           
           $param_id=APBD_GetValue("id");
           if(empty($param_id)){
                 $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }           
            $this->SetTitle("Edit API Key");
            if(APPSBD_IsPostBack){
                    $uobject=new Mapbd_apikey();
                    if($uobject->SetFromPostData(false)){
                        $uobject->SetWhereUpdate("id",$param_id);
                        if($uobject->Update()){
                            APBD_AddLog("U",$uobject->settedPropertyforLog(),"l002","");
                            $this->AddInfo("Successfully updated");
                            $this->DisplayPOPUPMsg();
                            return;
                        }
                    }
            }
            $mainobj=new Mapbd_apikey();
            $mainobj->id($param_id);
            if(!$mainobj->Select()){
                 $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }
            APBD_OldFields($mainobj, "api_key,title,api_ip,add_product,edit_product,view_product,add_client,edit_client,view_client,add_license,edit_license,view_license,entry_time,status");
            //$this->SetPopupFromMutipart();
            $this->AddViewData("mainobj", $mainobj);
            $this->AddViewData("isUpdateMode", true);           
            $this->DisplayPOPUP("add");
       } 
       
	   
	   function data(){	 
	        $mainResponse = new AppsbdAjaxDataResponse();   		
    		$mainResponse->setDownloadFileName("apbd-apikey-list");
        	$mainobj=new Mapbd_apikey();	  
        	$mainResponse->setDateRange($mainobj);  
            $records=$mainobj->CountALL($mainResponse->srcItem, $mainResponse->srcText,$mainResponse->multiparam,"after");
        	if($records>0){
        		$mainResponse->SetGridRecords($records);
        		//$mainResponse->setOrderByIfEmpty("id","DESC");
        	    //wp_apbd_apikey:id,api_key,api_ip,add_product,edit_product,view_product,add_client,edit_client,view_client,add_license,edit_license,view_license,entry_time,status		
        		$result=$mainobj->SelectAllGridData("id,api_key,title,api_ip,entry_time,status", $mainResponse->orderBy, $mainResponse->order, $mainResponse->rows, $mainResponse->limitStart, $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam,"after");
        		if($result){            	     
            	    
				
					$license_change=$mainobj->GetPropertyOptionsTag("view_license");
					$status_change=$mainobj->GetPropertyOptionsTag("status");  
            	                	    
        			foreach ($result as &$data){
        				$data->action="";
        				$data->action.="<a data-effect='mfp-move-from-top' class='popupformWR btn btn-info btn-xs' href='" .$this->GetActionUrl("edit",["id"=>$data->id])."'>".$this->__("Edit")."</a>";
        			    $data->action.=" <a class='ConfirmAjaxWR btn btn-danger btn-xs'  data-msg='".$this->__("Are you sure to delete?")."' href='" .$this->GetActionUrl("delete_item",["id"=>$data->id])."'>".$this->__("Delete")."</a>";
        			   
						/*$data->add_product=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("add_product_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->add_product,$license_change)."</a>";
						$data->edit_product=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("edit_product_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->edit_product,$license_change)."</a>";
						$data->view_product=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("view_product_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->view_product,$license_change)."</a>";
						$data->add_client=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("add_client_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->add_client,$license_change)."</a>";
						$data->edit_client=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("edit_client_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->edit_client,$license_change)."</a>";
						$data->view_client=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("view_client_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->view_client,$license_change)."</a>";
						$data->add_license=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("add_license_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->add_license,$license_change)."</a>";
						$data->edit_license=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("edit_license_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->edit_license,$license_change)."</a>";
						$data->view_license=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("view_license_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->view_license,$license_change)."</a>";
						*/
						$data->entry_time=APBD_getWPDateTimeWithFormat($data->entry_time);
						$data->status=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("status_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->status,$status_change)."</a>";
				
				        $data->action  =  apply_filters($this->getHookActionStr("api-list-action-button"),$data->action,$data,$this);
				        $data=apply_filters($this->getHookActionStr("api-list-row-data"),$data);
				        
        			}
        		}
        		$mainResponse->SetGridData($result);
    		}
    		$mainResponse->DisplayGridResponse();	    
	   }
    
	           
	    function delete_item(){
	        $mainResponse = new AppsbdAjaxConfirmResponse();
		    $param=APBD_GetValue("id");
            if(empty($param)){
                 $mainResponse->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }           
            $mr=new Mapbd_apikey();           
            $mr->id($param);
            if($mr->Select()){
                //$ur=new Mapbd_apikey();
                if(Mapbd_apikey::DeleteByID($param)){
                    APBD_AddLog("D","id={$param}", "l003","APBDAPIKey_confirm");
                    $mainResponse->DisplayWithResponse(true, __("Successfully deleted"));
                }else{
                    $mainResponse->DisplayWithResponse(false,__("Delete failed try again"));
                }
            }
        }
        
        function add_product_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_apikey();  
            $add_productChange=$mr->GetPropertyOptionsTag("add_product");
		         
            $mr->id($param);
            if($mr->Select("add_product")){
                $newStatus=$mr->add_product=="Y"?"N":"Y";
                $uo=new Mapbd_apikey();
                $uo->add_product($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->add_product, $add_productChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDAPIKey");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }

        function edit_product_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_apikey();  
            $edit_productChange=$mr->GetPropertyOptionsTag("edit_product");
		         
            $mr->id($param);
            if($mr->Select("edit_product")){
                $newStatus=$mr->edit_product=="Y"?"N":"Y";
                $uo=new Mapbd_apikey();
                $uo->edit_product($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->edit_product, $edit_productChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDAPIKey");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }

        function view_product_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_apikey();  
            $view_productChange=$mr->GetPropertyOptionsTag("view_product");
		         
            $mr->id($param);
            if($mr->Select("view_product")){
                $newStatus=$mr->view_product=="Y"?"N":"Y";
                $uo=new Mapbd_apikey();
                $uo->view_product($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->view_product, $view_productChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDAPIKey");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }

        function add_client_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_apikey();  
            $add_clientChange=$mr->GetPropertyOptionsTag("add_client");
		         
            $mr->id($param);
            if($mr->Select("add_client")){
                $newStatus=$mr->add_client=="Y"?"N":"Y";
                $uo=new Mapbd_apikey();
                $uo->add_client($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->add_client, $add_clientChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDAPIKey");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }

        function edit_client_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_apikey();  
            $edit_clientChange=$mr->GetPropertyOptionsTag("edit_client");
		         
            $mr->id($param);
            if($mr->Select("edit_client")){
                $newStatus=$mr->edit_client=="Y"?"N":"Y";
                $uo=new Mapbd_apikey();
                $uo->edit_client($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->edit_client, $edit_clientChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDAPIKey");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }

        function view_client_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_apikey();  
            $view_clientChange=$mr->GetPropertyOptionsTag("view_client");
		         
            $mr->id($param);
            if($mr->Select("view_client")){
                $newStatus=$mr->view_client=="Y"?"N":"Y";
                $uo=new Mapbd_apikey();
                $uo->view_client($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->view_client, $view_clientChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDAPIKey");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }

        function add_license_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_apikey();  
            $add_licenseChange=$mr->GetPropertyOptionsTag("add_license");
		         
            $mr->id($param);
            if($mr->Select("add_license")){
                $newStatus=$mr->add_license=="Y"?"N":"Y";
                $uo=new Mapbd_apikey();
                $uo->add_license($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->add_license, $add_licenseChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDAPIKey");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }

        function edit_license_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_apikey();  
            $edit_licenseChange=$mr->GetPropertyOptionsTag("edit_license");
		         
            $mr->id($param);
            if($mr->Select("edit_license")){
                $newStatus=$mr->edit_license=="Y"?"N":"Y";
                $uo=new Mapbd_apikey();
                $uo->edit_license($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->edit_license, $edit_licenseChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDAPIKey");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }

        function view_license_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_apikey();  
            $view_licenseChange=$mr->GetPropertyOptionsTag("view_license");
		         
            $mr->id($param);
            if($mr->Select("view_license")){
                $newStatus=$mr->view_license=="Y"?"N":"Y";
                $uo=new Mapbd_apikey();
                $uo->view_license($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->view_license, $view_licenseChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDAPIKey");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }

        function status_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_apikey();  
            $statusChange=$mr->GetPropertyOptionsTag("status");
		         
            $mr->id($param);
            if($mr->Select("status")){
                $newStatus=$mr->status=="A"?"I":"A";
                $uo=new Mapbd_apikey();
                $uo->status($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->status, $statusChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDAPIKey");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }
                
       
       
    
}