<?php
//Elite Licenser
class APBDBanHost extends AppsBDBaseModule{
    
      
	    
	   function initialize() {
            parent::initialize();
            $this->disableDefaultForm();
            $this->AddAjaxAction("add",[$this,"add"]);
            $this->AddAjaxAction("edit",[$this,"edit"]);
            $this->AddAjaxAction("unban",[$this,"unban_item"]);
            $this->setIsHiddenModule(true);
        }
    
        function OptionForm() {
            $this->SetTitle("Ban Host List");
    	    
            $this->Display();
        }
        
        function GetMenuTitle() {
            return $this->__( "Ban Host" );
        }
        
        function GetMenuSubTitle() {
            return $this->__( "View all Ban Hosts" );
        }
        
        function GetMenuIcon() {
            return "ap ap-ban-host";
        } 
       
       function add(){
            $this->SetTitle("Add Ban Host ");
            $this->SetPOPUPColClass ( "col-sm-6" );
           
            if(APPSBD_IsPostBack){
                $nobject=new Mapbd_ban_host();
                if($nobject->SetFromPostData(true)){
                    if($nobject->Save()){
                        $this->AddInfo("Successfully added");
                        APBD_AddLog("A",$nobject->settedPropertyforLog(),"l001","");
                        $this->DisplayPOPUPMsg();
                        return;
                    }
                }
            }
            $mainobj=new Mapbd_ban_host();
            //$this->SetPopupFromMutipart();     
            $this->AddViewData("isUpdateMode",false);
            $this->AddViewData("mainobj",$mainobj);
            $this->DisplayPOPUp("add");
	    }	    
       function edit($param_id=""){
            $this->SetPOPUPColClass ( "col-sm-6" );
           
           $param_id=APBD_GetValue("id");
           if(empty($param_id)){
                 $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }           
            $this->SetTitle("Edit Ban Host");
            if(APPSBD_IsPostBack){
                    $uobject=new Mapbd_ban_host();
                    if($uobject->SetFromPostData(false)){
                        $uobject->SetWhereUpdate("id",$param_id);
                        if($uobject->Update()){
                            APBD_AddLog("U",$uobject->settedPropertyforLog(),"l002","");
                            $this->AddInfo("Successfully updated");
                            $this->DisplayPOPUPMsg();
                            return;
                        }
                    }
            }
            $mainobj=new Mapbd_ban_host();
            $mainobj->id($param_id);
            if(!$mainobj->Select()){
                 $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }
            APBD_OldFields($mainobj, "host,ip,status,req_counter");
            //$this->SetPopupFromMutipart();
            $this->AddViewData("mainobj", $mainobj);
            $this->AddViewData("isUpdateMode", true);           
            $this->DisplayPOPUP("add");
       } 
       
	   
	   function data() {
		   $mainResponse = new AppsbdAjaxDataResponse();
		   $mainResponse->setDownloadFileName( "apbd-ban-host-list" );
		   $mainobj = new Mapbd_ban_host();
		   $mainResponse->setDateRange( $mainobj );
		   $records = $mainobj->CountALL( $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam, "both" );
		   if ( $records > 0 ) {
			   $mainResponse->SetGridRecords( $records );
			   $mainResponse->setOrderByIfEmpty( "id", "DESC" );
			   //wp_apbd_ban_host:id,host,ip,status,req_counter
			   $result = $mainobj->SelectAllGridData( "", $mainResponse->orderBy, $mainResponse->order, $mainResponse->rows, $mainResponse->limitStart, $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam, "both" );
			   if ( $result ) {
				
				   $status_options = $mainobj->GetPropertyOptionsTag( "status" );
				
				   foreach ( $result as &$data ) {
					   $data->action = "";
					   $oldst        = $data->status;
					   $data->status = APBD_getTextByKey( $data->status, $status_options );
					   if ( $oldst == "B" ) {
						   $data->status .= "  <a class='ConfirmAjaxWR btn btn-danger btn-xs'  data-on-complete='APBD_ban_host_unban'  data-msg='" . $this->__( "Are you sure to unban for this host(" . $data->host . ")?" ) . "' href='" . $this->GetActionUrl( "unban", [ "id" => $data->id ] ) . "'>" . $this->__( "Unban" ) . "</a>";
					   }
					
					   $data->action = apply_filters( $this->getHookActionStr( "banhost-list-action-button" ), $data->action, $data, $this );
					   $data         = apply_filters( $this->getHookActionStr( "banhost-list-row-data" ), $data );
					
				   }
			   }
			   $mainResponse->SetGridData( $result );
		   }
		   $mainResponse->DisplayGridResponse();
	   }
    
	           
	    function unban_item(){
	        $mainResponse = new AppsbdAjaxConfirmResponse();
            //temporary
		    $param=APBD_GetValue("id");
            if(empty($param)){
                 $mainResponse->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }           
            $mr=new Mapbd_ban_host();           
            $mr->id($param);
            if($mr->Select() && $mr->status=="B"){
                //$ur=new Mapbd_ban_host();
                if(Mapbd_ban_host::resetHost($param)){
                    APBD_AddLog("U","id={$param}", "l003","APBDBanHost_confirm");
                    $mainResponse->DisplayWithResponse(true, __("Successfully unbanned"));
                    return;
                }
            }
	            $mainResponse->DisplayWithResponse(false,__("Invalid param"));
            
        }
                        
       
       
    
}