<?php
//Elite Licenser
class APBDLicIntegration extends AppsBDBaseModule {
	
	/**
	 * @var APBDLicIntegrator []
	 */
	public static $markets=[];
	private static $instance;
	
	/**
	 * @return mixed
	 */
	public static function getInstance() {
		return self::$instance;
	}
	
	function initialize() {
		parent::initialize();
		self::$instance =$this;
		$this->disableDefaultForm();
		
	}
	function OnInit() {
		parent::OnInit();
		APBDLicIntegration::RegisterMarket(new EnvatoIntegrator("Envato","ap ap-envato"));
		APBDLicIntegration::RegisterMarket(new PaddleIntegrator("Paddle","ap ap-paddle"));
		APBDLicIntegration::RegisterMarket(new FastSpringIntegrator("FastSpring","ap ap-fastspring"));
		//hoock elite_licenser/register_integration
		do_action($this->getHookActionStr("register_integration"));
		
	}
	
	function OnActive() {
		parent::OnActive();
	}
	static function RegisterMarket($integratorObject) {
		self::$markets[]=$integratorObject;
	}
	static function CheckIntegratedLicense($postData){
		foreach ( self::$markets  as $market ) {
			$found=$market->CheckLicenseKey($postData);
			if(!empty($found) && ($found instanceof Mapbd_license)){
				return $found;
			}
		}
		return null;
	}
	function Envato(){
		$this->SetTitle( "Envato" );
		
		$this->Display();
	}
	function OptionForm() {
		$this->SetTitle( "Integration" );
		
		$this->Display();
	}
	
	
	function GetMenuTitle() {
		return $this->__( "Integration" );
	}
	
	function GetMenuSubTitle() {
		return $this->__( "Setup your 3rd party integration" );
	}
	
	function GetMenuIcon() {
		return "ap ap-third-party-integration";
	}
	public static function getMarkets(){
		return self::$markets;
	}
	
}