<?php
//Elite Licenser
class APBDLicenseType extends AppsBDBaseModule{
    
      
	    
	   function initialize() {
            parent::initialize();
            $this->disableDefaultForm();
            $this->AddAjaxAction("add",[$this,"add"]);
            $this->AddAjaxAction("edit",[$this,"edit"]);
            $this->AddAjaxAction("delete_item",[$this,"delete_item"]);             
            
			$this->AddAjaxAction("has_expiry_change",[$this,"has_expiry_change"]);
			$this->AddAjaxAction("has_support_change",[$this,"has_support_change"]);
			$this->AddAjaxAction("status_change",[$this,"status_change"]);
        }
    
        function OptionForm() {
            $this->SetTitle("License Types");
    	    
            $this->Display();
        }
        
        function GetMenuTitle() {
            return $this->__( "License Type" );
        }
        
        function GetMenuSubTitle() {
            return $this->__( "View all License Type" );
        }
        
        function GetMenuIcon() {
            return "ap ap-license-type";
        } 
       
       function add(){
            $this->SetTitle("Add License Type");
            $this->SetPOPUPColClass ( "col-sm-7" );
           
            if(APPSBD_IsPostBack){
                $nobject=new Mapbd_license_type();
                if($nobject->SetFromPostData(true)){
                    if($nobject->Save()){
                        $this->AddInfo("Successfully added");
                        APBD_AddLog("A",$nobject->settedPropertyforLog(),"l001","");
                        $this->DisplayPOPUPMsg();
                        return;
                    }
                }
            }
            $mainobj=new Mapbd_license_type();
            //$this->SetPopupFromMutipart();     
            $this->AddViewData("isUpdateMode",false);
            $this->AddViewData("mainobj",$mainobj);
            $this->DisplayPOPUp("add");
	    }	    
       function edit(){
            $this->SetPOPUPColClass ( "col-sm-7" );
           
           $param_id=APBD_GetValue("id");
           if(empty($param_id)){
                 $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }           
            $this->SetTitle("Edit License Type");
            if(APPSBD_IsPostBack){
                $uobject=new Mapbd_license_type();
                if($uobject->SetFromPostData(false)){
                    $uobject->SetWhereUpdate("id",$param_id);
                    $isTitleSet=$uobject->IsSetPrperty('license_title');
                    if($uobject->Update()){
                         if($uobject){
                            Mapbd_license::ReplaceLicenseTitle($param_id,$uobject->license_title);
                         }
                        APBD_AddLog("U",$uobject->settedPropertyforLog(),"l002","");
                        $this->AddInfo("Successfully updated");
                        $this->DisplayPOPUPMsg();
                        return;
                    }
                }
            }
            $mainobj=new Mapbd_license_type();
            $mainobj->id($param_id);
            if(!$mainobj->Select()){
                 $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }
            APBD_OldFields($mainobj, "license_title,is_unlimited,extra_param,max_domain,verification_required,has_expiry,days_of_expiry,has_support,days_of_support,status");
            //$this->SetPopupFromMutipart();
            $this->AddViewData("mainobj", $mainobj);
            $this->AddViewData("isUpdateMode", true);           
            $this->DisplayPOPUP("add");
       } 
       
	   
	   function data(){	 
	        $mainResponse = new AppsbdAjaxDataResponse();   		
    		$mainResponse->setDownloadFileName("apbd-license-type-list");
        	$mainobj=new Mapbd_license_type();	  
        	$mainResponse->setDateRange($mainobj);  
            $records=$mainobj->CountALL($mainResponse->srcItem, $mainResponse->srcText,$mainResponse->multiparam,"after");
        	if($records>0){
        		$mainResponse->SetGridRecords($records);
        		//$mainResponse->setOrderByIfEmpty("id","DESC");
        	    //wp_apbd_license_type:id,license_title,max_domain,verification_required,has_expiry,days_of_expiry,has_support,days_of_support,status		
        		$result=$mainobj->SelectAllGridData("", $mainResponse->orderBy, $mainResponse->order, $mainResponse->rows, $mainResponse->limitStart, $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam,"after");
        		if($result){            	     
            	    
					$has_expiry_change=$mainobj->GetPropertyOptionsTag("has_expiry");  
					$has_support_change=$mainobj->GetPropertyOptionsTag("has_support");  
					$status_change=$mainobj->GetPropertyOptionsTag("status");  
            	                	    
        			foreach ($result as &$data){
				        $data->license_title.=' <span class="text-success">( ID:'.$data->id.')</span>';
        				$data->action="";
        				$data->action.="<a data-effect='mfp-move-from-top' class='popupformWR btn btn-info btn-xs' href='" .$this->GetActionUrl("edit",["id"=>$data->id])."'>".$this->__("Edit")."</a>";
        			    $data->action.=" <a class='ConfirmAjaxWR btn btn-danger btn-xs' data-on-complete='APBD_license_type_reload' data-msg='".$this->__("Are you sure to delete?")."' href='" .$this->GetActionUrl("delete_item",["id"=>$data->id])."'>".$this->__("Delete")."</a>";
        			    if($data->has_expiry!='Y'){
				            $data->days_of_expiry='-';
			            }
        			    if($data->is_unlimited=='Y'){
					        $data->max_domain='∞';
				        }
						$data->has_expiry=" <a class='ConfirmAjaxWR' data-on-complete='APBD_license_type_reload' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("has_expiry_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->has_expiry,$has_expiry_change)."</a>";
						//$data->has_support=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("has_support_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->has_support,$has_support_change)."</a>";
						if(in_array($data->has_support,['U','N'])){
							$data->days_of_support="-";
						}
				        $data->has_support=APBD_getTextByKey($data->has_support,$has_support_change);
						$data->status=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("status_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->status,$status_change)."</a>";
				       
				        $data->action  =  apply_filters($this->getHookActionStr("license-type-list-action-button"),$data->action,$data,$this);
				        $data=apply_filters($this->getHookActionStr("license-type-list-row-data"),$data);
				
				
			        }
        		}
        		$mainResponse->SetGridData($result);
    		}
    		$mainResponse->DisplayGridResponse();	    
	   }
    
	           
	    function delete_item($param=""){
	        $mainResponse = new AppsbdAjaxConfirmResponse();
		    $param=APBD_GetValue("id");
            if(empty($param)){
                 $mainResponse->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }           
            $mr=new Mapbd_license_type();           
            $mr->id($param);
            if($mr->Select()){
                //$ur=new Mapbd_license_type();
                if(Mapbd_license_type::DeleteByID($param)){
                    APBD_AddLog("D","id={$param}", "l003","APBDLicenseType_confirm");
                    $mainResponse->DisplayWithResponse(true, __("Successfully deleted"));
                }else{
                    $mainResponse->DisplayWithResponse(false,__("Delete failed try again"));
                }
            }
        }
        
        function has_expiry_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_license_type();  
            $has_expiryChange=$mr->GetPropertyOptionsTag("has_expiry");
		         
            $mr->id($param);
            if($mr->Select("has_expiry")){
                $newStatus=$mr->has_expiry=="Y"?"N":"Y";
                $uo=new Mapbd_license_type();
                $uo->has_expiry($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->has_expiry, $has_expiryChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDLicenseType");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }

        function has_support_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_license_type();  
            $has_supportChange=$mr->GetPropertyOptionsTag("has_support");
		         
            $mr->id($param);
            if($mr->Select("has_support")){
                $newStatus=$mr->has_support=="Y"?"N":"Y";
                $uo=new Mapbd_license_type();
                $uo->has_support($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->has_support, $has_supportChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDLicenseType");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }

        function status_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_license_type();  
            $statusChange=$mr->GetPropertyOptionsTag("status");
		         
            $mr->id($param);
            if($mr->Select("status")){
                $newStatus=$mr->status=="A"?"I":"A";
                $uo=new Mapbd_license_type();
                $uo->status($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->status, $statusChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","APBDLicenseType");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }
                
       
       
    
}