<?php
//Elite Licenser
class APBDRequestManage extends AppsBDBaseModule{
    
      
	    
	   function initialize() {
            parent::initialize();
            $this->disableDefaultForm();
            $this->AddAjaxAction("add",[$this,"add"]);
            $this->AddAjaxAction("edit",[$this,"edit"]);
            $this->AddAjaxAction("delete_item",[$this,"delete_item"]);             
            
			$this->AddAjaxAction("status_change",[$this,"status_change"]);
        }
    
        function OptionForm() {
            $this->SetTitle("Request Manage List");
    	    
            $this->Display();
        }
        
        function GetMenuTitle() {
            return $this->__( "Request Manage" );
        }
        
        function GetMenuSubTitle() {
            return $this->__( "View all Request Manage Item" );
        }
        
        function GetMenuIcon() {
            return "ap ap-request-manager";
        } 
       
       function add(){
            $this->SetTitle("Add Manage Item ");
            $this->SetPOPUPColClass ( "col-sm-8" );
           
            if(APPSBD_IsPostBack){
                $nobject=new Mapbd_request_manage();
                if($nobject->SetFromPostData(true)){
                    if($nobject->Save()){
                        $this->AddInfo("Successfully added");
                        APBD_AddLog("A",$nobject->settedPropertyforLog(),"l001","");
                        $this->DisplayPOPUPMsg();
                        return;
                    }
                }
            }
            $mainobj=new Mapbd_request_manage();
            //$this->SetPopupFromMutipart();     
            $this->AddViewData("isUpdateMode",false);
            $this->AddViewData("mainobj",$mainobj);
            $this->DisplayPOPUp("add");
	    }	    
       function edit($param_id=""){
            $this->SetPOPUPColClass ( "col-sm-8" );
           
           $param_id=APBD_GetValue("id");
           if(empty($param_id)){
                 $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }           
            $this->SetTitle("Edit Manage Item");
            if(APPSBD_IsPostBack){
                    $uobject=new Mapbd_request_manage();
                    if($uobject->SetFromPostData(false)){
                        $uobject->SetWhereUpdate("id",$param_id);
                        if($uobject->Update()){
                            APBD_AddLog("U",$uobject->settedPropertyforLog(),"l002","");
                            $this->AddInfo("Successfully updated");
                            $this->DisplayPOPUPMsg();
                            return;
                        }
                    }
            }
            $mainobj=new Mapbd_request_manage();
            $mainobj->id($param_id);
            if(!$mainobj->Select()){
                 $this->AddError("Invalid request");
                $this->DisplayPOPUPMsg();
                return;
            }
            APBD_OldFields($mainobj, "title,duration_type,duration,duration_in_hour,counter_limit,status");
            //$this->SetPopupFromMutipart();
            $this->AddViewData("mainobj", $mainobj);
            $this->AddViewData("isUpdateMode", true);           
            $this->DisplayPOPUP("add");
       } 
       
	   
	   function data(){	 
	        $mainResponse = new AppsbdAjaxDataResponse();   		
    		$mainResponse->setDownloadFileName("request-manage-list");
        	$mainobj=new Mapbd_request_manage();	  
        	$mainResponse->setDateRange($mainobj);  
            $records=$mainobj->CountALL($mainResponse->srcItem, $mainResponse->srcText,$mainResponse->multiparam,"after");
        	if($records>0){
        		$mainResponse->SetGridRecords($records);
        		//$mainResponse->setOrderByIfEmpty("id","DESC");
        	    //wp_apbd_request_manage:id,title,duration_type,duration,duration_in_hour,counter_limit,status		
        		$result=$mainobj->SelectAllGridData("", $mainResponse->orderBy, $mainResponse->order, $mainResponse->rows, $mainResponse->limitStart, $mainResponse->srcItem, $mainResponse->srcText, $mainResponse->multiparam,"after");
        		if($result){            	     
            	    
					$status_change=$mainobj->GetPropertyOptionsTag("status");  
            	    $duration_type_options=$mainobj->GetPropertyOptionsTag("duration_type");
					            	    
        			foreach ($result as &$data){
        				$data->action="";
        				$data->action.="<a data-effect='mfp-move-from-top' class='popupformWR btn btn-info btn-xs' href='" .$this->GetActionUrl("edit",["id"=>$data->id])."'>".$this->__("Edit")."</a>";
        			    $data->action.=" <a class='ConfirmAjaxWR btn btn-danger btn-xs'  data-msg='".$this->__("Are you sure to delete?")."' href='" .$this->GetActionUrl("delete_item",["id"=>$data->id])."'>".$this->__("Delete")."</a>";
        			   
						$data->status=" <a class='ConfirmAjaxWR' data-on-complete='APPSBDAPPJS.confirmAjax.ConfirmWRChange' data-msg='".$this->__("Are you sure to change?")."' href='" .$this->GetActionUrl("status_change",["id"=>$data->id])."'>".APBD_getTextByKey($data->status,$status_change)."</a>";
        			   
						$data->duration=$this->___("App,Theme or Plugin request for license check on every %d %s until %d times then next",$data->duration,APBD_getTextByKey($data->duration_type,$duration_type_options),$data->counter_limit);
				
				        $data->action  =  apply_filters($this->getHookActionStr("request-manage-list-action-button"),$data->action,$data,$this);
				        $data=apply_filters($this->getHookActionStr("request-manage-list-row-data"),$data);
				
				
			        }
        		}
        		$mainResponse->SetGridData($result);
    		}
    		$mainResponse->DisplayGridResponse();	    
	   }
    
	           
	    function delete_item(){
		    $param=APBD_GetValue("id");
	        $mainResponse = new AppsbdAjaxConfirmResponse();
            if(empty($param)){
                 $mainResponse->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }           
            $mr=new Mapbd_request_manage();           
            $mr->id($param);
            if($mr->Select()){
                //$ur=new Mapbd_request_manage();
                if(Mapbd_request_manage::DeleteById($param)){
                    APBD_AddLog("D","id={$param}", "l003","Wp_apbd_request_manage_confirm");
                    $mainResponse->DisplayWithResponse(true, __("Successfully deleted"));
                }else{
                    $mainResponse->DisplayWithResponse(false,__("Delete failed try again"));
                }
            }
        }
        
        function status_change(){
           $param=APBD_GetValue("id");
           if(empty($param)){
                 $this->DisplayWithResponse(false, __("Invalid Request"));
                 return;
            }
            $mainResponse = new AppsbdAjaxConfirmResponse();
            $mr=new Mapbd_request_manage();  
            $statusChange=$mr->GetPropertyOptionsTag("status");
		         
            $mr->id($param);
            if($mr->Select("status")){
                $newStatus=$mr->status=="A"?"I":"A";
                $uo=new Mapbd_request_manage();
                $uo->status($newStatus);
                $uo->SetWhereUpdate("id",$param); 
                if( $uo->Update()){
                    $status_text = APBD_getTextByKey($uo->status, $statusChange);
                    APBD_AddLog("U",$uo->settedPropertyforLog(), "l002","Wp_apbd_request_manage");
                    $mainResponse->DisplayWithResponse(true, __("Successfully Updated"), $status_text);
                }else{
                    $mainResponse->DisplayWithResponse(false, __("Update failed try again"));
                }   
                
            }
            
        }
                
       
       
    
}