﻿Imports EliteLicenser
Module Program

    Sub Main()
        ''Dim LB As EliteLicenser.LicenserBase = New EliteLicenser.LicenserBase("Product Key", "Product Id", "Product Base", "Host url ex. https://example.com/wp-json/lic")
        Dim LB As EliteLicenser.LicenserBase = New EliteLicenser.LicenserBase("<<encryptedkey>>", "<<productid>>", "<<productbase>>", "<<hostserver>>")
        Dim LicenseKey As String = "THIS WILL BE THE LICENSE KEY" ''Collect this license key using input box
        Dim AppUniqueId As String = EliteLicenser.EliteMachine.GetUniqueMachineId("<<productname>>_OR_ANYTHING")
        Console.WriteLine("Machine Id:" & AppUniqueId)
        Dim AppVersion As String = "1.0"
        Dim AdminEmail As String = "Admin@email.com" ''Collect this license key using input box
        Console.WriteLine(vbLf & "Activating Update...." & vbLf & "------------------------------------------")

        If LB.Active(LicenseKey, AppUniqueId, AppVersion, AdminEmail) Then
            Console.WriteLine("Activated Successfully")
            Console.WriteLine("License Key : " & LicenseKey)
            Console.WriteLine("License Title : " & LB.EO.license_title)
            Console.WriteLine("License Expire Date : " & LB.EO.expire_date)
            Console.WriteLine("License Support Date : " & LB.EO.support_end)
        Else
            Console.WriteLine("Activation Failed")
            Console.WriteLine("Error : " & LB.ErrorMessage)
        End If

        Console.WriteLine("------------------------------------------" & vbLf & vbLf & "Press any key to check update")
        Console.ReadKey()
        Console.WriteLine(vbLf & vbLf & "Checking Update...." & vbLf & "------------------------------------------")
        Dim uo As EliteUpdateResponse = LB.GetUpdateInfo(LicenseKey)

        If uo.status Then
            Console.WriteLine("New Version:" & uo.data.new_version)
            Console.WriteLine(vbLf & "Description:" & vbLf & "--------------" & vbLf & uo.data.sections("description"))
            Console.WriteLine(vbLf & vbLf & "Change Log:" & vbLf & "-------------" & vbLf & uo.data.sections("changelog") & vbLf)

            If String.IsNullOrEmpty(uo.data.download_link) Then

                If uo.data.update_denied_type = "L" Then
                    Console.WriteLine("Not updateable : License key required")
                ElseIf uo.data.update_denied_type = "S" Then
                    Console.WriteLine("Not updateable : Support Expired")
                Else
                    Console.WriteLine("Not updateable : Unknown reason")
                End If
            Else
                Console.WriteLine("Download Link:" & uo.data.download_link)
            End If

            Console.WriteLine(vbLf & vbLf & "------------------------------------------" & vbLf & vbLf & "Press any key to deactivate")
            Console.ReadKey()
        Else
            Console.WriteLine(uo.msg)
        End If

        If LB.IsLicenseActivated Then
            Console.WriteLine(vbLf & "Now Deactivating...." & vbLf & "------------------------------------------")

            If LB.Deactive(LicenseKey) Then
                Console.WriteLine("License Dactivated Successfully")
            Else
                Console.WriteLine("Dactivation Failed")
                Console.WriteLine("Error : " & LB.ErrorMessage)
            End If

            Console.ReadKey()
        End If

    End Sub

End Module
