<?php
<<requirelink>>
class <<product_class_name_without_space>> {
	public $plugin_file=__FILE__;
	public $response_obj;
	public $license_message;
	public $show_message=false;
	public $slug='<<productbase>>';
	public $plugin_version='';
	public $text_domain='';
	function __construct() {
		add_action( 'admin_print_styles', [ $this, 'set_admin_style' ] );
		$this->set_plugin_data();
		$main_lic_key="<<productname_without_space>>_lic_Key";
		$lic_key_name =<<baseclassname>>::get_lic_key_param($main_lic_key);
        $license_key=get_option($lic_key_name,'');
        if(empty($license_key)){
	        $license_key=get_option($main_lic_key,'');
	        if(!empty($license_key)){
		        update_option($lic_key_name,$license_key) || add_option($lic_key_name,$license_key);
		        update_option($main_lic_key,'');
		       
	        }
        }
		$lice_email=get_option( "<<productname_without_space>>_lic_email",'');
		$template_dir=get_stylesheet_directory(); //or dirname(__FILE__);
		if(<<baseclassname>>::check_wp_plugin($license_key,$lice_email,$this->license_message,$this->response_obj,$template_dir."/<<themestylecss>>")){
			add_action( 'admin_menu', [$this,'active_admin_menu'],99999);
			add_action( 'admin_post_<<productname_without_space>>_el_deactivate_license', [ $this, 'action_deactivate_license' ] );
			//$this->licenselMessage=$this->mess;
			//***Write you plugin's code here***

		}else{
			if(!empty($license_key) && !empty($this->license_message)){
				$this->show_message=true;
			}
			$main_lic_key="<<productname_without_space>>_lic_Key";
			$lic_key_name =<<baseclassname>>::get_lic_key_param($main_lic_key);
			update_option($lic_key_name,'') || add_option($lic_key_name,'');
			add_action( 'admin_post_<<productname_without_space>>_el_activate_license', [ $this, 'action_activate_license' ] );
			add_action( 'admin_menu', [$this,'inactive_menu']);
		}
	}
	public function set_plugin_data(){
		if ( ! function_exists( 'get_plugin_data' ) ) {
			require_once ABSPATH . 'wp-admin/includes/plugin.php';
		}
		if ( function_exists( 'get_plugin_data' ) ) {
			$data = get_plugin_data( $this->plugin_file );
			if ( isset( $data['Version'] ) ) {
				$this->plugin_version = $data['Version'];
			}
			if ( isset( $data['TextDomain'] ) ) {
				$this->text_domain = $data['TextDomain'];
			}
		}
	}
	public function set_admin_style() {
		wp_register_style( "<<productname_without_space>>Lic", get_theme_file_uri("_lic_style.css"),10,$this->plugin_version);
		wp_enqueue_style( "<<productname_without_space>>Lic" );
	}
	public function active_admin_menu(){
		 <<activatedmenu>>
	}
	public function inactive_menu() {
		add_menu_page( "<<productname_without_space>>", "<<productname>>", 'activate_plugins', $this->slug,  [$this,"license_form"], <<icon_or_file>> );
		
	}
	public function action_activate_license(){
		check_admin_referer( 'el-license' );
		$license_key=!empty($_POST['el_license_key'])?sanitize_text_field( wp_unslash($_POST['el_license_key'])):'';
		$licenseEmail=!empty($_POST['el_license_email'])?sanitize_email( wp_unslash($_POST['el_license_email'])):'';
		update_option("<<productname_without_space>>_lic_Key",$license_key) || add_option("<<productname_without_space>>_lic_Key",$license_key);
		update_option("<<productname_without_space>>_lic_email",$licenseEmail) || add_option("<<productname_without_space>>_lic_email",$licenseEmail);
		update_option('_site_transient_update_themes','');
		wp_safe_redirect(admin_url( 'admin.php?page='.$this->slug));
	}
	public function action_deactivate_license() {
		check_admin_referer( 'el-license' );
		$message='';
		if(<<baseclassname>>::remove_license_key(__FILE__,$message)){
			$main_lic_key="<<productname_without_space>>_lic_Key";
			$lic_key_name =<<baseclassname>>::get_lic_key_param($main_lic_key);
			update_option($lic_key_name,'') || add_option($lic_key_name,'');
			update_option('_site_transient_update_themes','');
		}
    	wp_safe_redirect(admin_url( 'admin.php?page='.$this->slug));
    }
	public function activated(){
		?>
        <form method="post" action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>">
            <input type="hidden" name="action" value="<<productname_without_space>>_el_deactivate_license"/>
            <div class="el-license-container">
                <h3 class="el-license-title"><i class="dashicons-before dashicons-star-filled"></i> <?php esc_attr_e("<<productname>> License Info",'<<productbase>>');?> </h3>
                <hr>
                <ul class="el-license-info">
                <li>
                    <div>
                        <span class="el-license-info-title"><?php esc_html_e("Status",'<<productbase>>');?></span>

                        <?php if ( $this->response_obj->is_valid ) : ?>
                            <span class="el-license-valid"><?php esc_html_e("Valid",'<<productbase>>');?></span>
                        <?php else : ?>
                            <span class="el-license-valid"><?php esc_html_e("Invalid",'<<productbase>>');?></span>
                        <?php endif; ?>
                    </div>
                </li>

                <li>
                    <div>
                        <span class="el-license-info-title"><?php esc_html_e("License Type",'<<productbase>>');?></span>
                        <?php echo esc_html($this->response_obj->license_title,'<<productbase>>'); ?>
                    </div>
                </li>

               <li>
                   <div>
                       <span class="el-license-info-title"><?php esc_html_e("License Expired on",'<<productbase>>');?></span>
                       <?php echo esc_html($this->response_obj->expire_date,'<<productbase>>');
                       if(!empty($this->response_obj->expire_renew_link)){
                           ?>
                           <a target="_blank" class="el-blue-btn" href="<?php echo esc_url($this->response_obj->expire_renew_link); ?>">Renew</a>
                           <?php
                       }
                       ?>
                   </div>
               </li>

               <li>
                   <div>
                       <span class="el-license-info-title"><?php esc_attr_e("Support Expired on",'<<productbase>>');?></span>
                       <?php
	                       echo esc_html($this->response_obj->support_end,'<<productbase>>');
                        if(!empty($this->response_obj->support_renew_link)){
                            ?>
                               <a target="_blank" class="el-blue-btn" href="<?php echo esc_url($this->response_obj->support_renew_link); ?>"><?php  esc_attr_e("Renew",'<<productbase>>')?></a>
                            <?php
                        }
                       ?>
                   </div>
               </li>
                <li>
                    <div>
                        <span class="el-license-info-title"><?php esc_html_e("Your License Key",'<<productbase>>');?></span>
                        <span class="el-license-key"><?php echo esc_attr( substr($this->response_obj->license_key,0,9)."XXXXXXXX-XXXXXXXX".substr($this->response_obj->license_key,-9) ); ?></span>
                    </div>
                </li>
                </ul>
                <div class="el-license-active-btn">
                    <?php wp_nonce_field( 'el-license' ); ?>
                    <?php submit_button('Deactivate'); ?>
                </div>
            </div>
        </form>
		<?php
	}
	
	public function license_form() {
		?>
        <form method="post" action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>">
            <input type="hidden" name="action" value="<<productname_without_space>>_el_activate_license"/>
            <div class="el-license-container">
                <h3 class="el-license-title"><i class="dashicons-before dashicons-star-filled"></i> <?php esc_attr_e("<<productname>> Theme Licensing",'<<productbase>>');?></h3>
                <hr>
				<?php
					if(!empty($this->show_message) && !empty($this->license_message)){
						?>
                        <div class="notice notice-error is-dismissible">
                            <p><?php echo esc_html($this->license_message,'<<productbase>>'); ?></p>
                        </div>
						<?php
					}
				?>
                <<lic_form_header>>
    		    <div class="el-license-field">
    			    <label for="el_license_key"><?php esc_html_e("License code",'<<productbase>>');?></label>
    			    <input type="text" class="regular-text code" name="el_license_key" size="50" placeholder="xxxxxxxx-xxxxxxxx-xxxxxxxx-xxxxxxxx" required="required">
    		    </div>
                <div class="el-license-field">
                    <label for="el_license_key"><?php esc_html_e("Email Address",'<<productbase>>');?></label>
                    <?php
                        $purchaseEmail   = get_option( "<<productname_without_space>>_lic_email", get_bloginfo( 'admin_email' ));
                    ?>
                    <input type="text" class="regular-text code" name="el_license_email" size="50" value="<?php echo esc_html($purchaseEmail); ?>"  required="required">
                    <div><small><?php esc_html_e("We will send update news of this product by this email address, don't worry, we hate spam",'<<productbase>>');?></small></div>
                </div>
                <div class="el-license-active-btn">
					<?php wp_nonce_field( 'el-license' ); ?>
					<?php submit_button('Activate'); ?>
                </div>
            </div>
        </form>
		<?php
	}
}

new <<product_class_name_without_space>>();