<?php
	/** @var APBDLicenseList $this
	 *  @var Mapbd_upload $mainobj;
	 */
?>
<div class="clearfix form pb-3">
    <div class="card">
        <div class="card-body pt-0 pb-0">
            <div class="row">
                <div class="col-sm p-0">
                    <table class="table m-0">
                        <tr>
                            <th><?php $this->_e("Product Name") ; ?></th>
                            <th >:</th>
                            <td><?php echo $mainobj->name; ?></td>
                        </tr>
                        <tr>
                            <th><?php $this->_e("Version") ; ?></th>
                            <th>:</th>
                            <td><?php echo $mainobj->version; ?></td>
                        </tr>
                        <tr>
                            <th><?php $this->_e("Author") ; ?></th>
                            <th>:</th>
                            <td ><?php echo $mainobj->author; ?></td>
                        </tr>
                        <tr>
                            <th><?php $this->_e("Product Type") ; ?></th>
                            <th>:</th>
                            <td><?php echo $mainobj->is_theme=="Y"?$this->__("Theme"):$this->__("Plugin"); ?></td>
                        </tr>
                        <tr>
                            <th ><?php $this->_e("TextDomain") ; ?></th>
                            <th>:</th>
                            <td  class="text-info"><?php echo $mainobj->textdomain; ?></td>
                        </tr>
                       
                        
                    </table>
                </div>
                <div class="col-sm p-0">
                    <table class="table m-0">
                        
                        <tr>
                            <th><?php $this->_e("Has Own Menu") ; ?></th>
                            <th>:</th>
                            <td><?php echo $mainobj->getTextByKey("has_own_menu");?></td>
                        </tr>
                        <tr>
                            <th><?php $this->_e("Icon Type") ; ?></th>
                            <th>:</th>
                            <td><?php echo $mainobj->getTextByKey("icon_type");?></td>
                        </tr>
                        <tr>
                            <th><?php $this->_e("Upload Time") ; ?></th>
                            <th>:</th>
                            <td><?php echo APBD_getWPDateTimeWithFormat($mainobj->upload_time);?></td>
                        </tr>
                        <tr>
                            <th><?php $this->_e("Target Elite Product") ; ?></th>
                            <th>:</th>
                            <td><?php
					                $product=Mapbd_product::FindBy("id",$mainobj->target_product);
					                echo $product?$product->product_name:$mainobj->target_product;
				                ?></td>
                        </tr>
                        <tr>
                            <th><?php $this->_e("Target Elite Product Slug") ; ?></th>
                            <th>:</th>
                            <td class="text-info"><?php
					                echo $product?$product->product_base:"";
				                ?></td>
                        </tr>
                    </table>
                </div>
            </div>
            <hr class="">
            <div class="row">
                <div class="col-sm text-center">
    
                    <h2><i class="fa fa-smile-o"></i> <?php $this->_e("Your product is ready to download") ; ?></h2>
                </div>
            </div>
            <div class="row">
                <div class="col-sm text-center pt-3">
                    <div class="input-group-prepend has-mat-sw ">
                        <div class="m-auto">
                            <?php
                                APBD_GetHTMLRadioByArray("dlversion","dlversion","dlversion",true,["N"=>"Licensed Version","Y"=>"Licensed Version - Encrypted"],'N',false,true,"has_depend_fld");
                                //APBD_GetHTMLSwitchButton("has_support","has_support","N","Y",$mainobj->GetPostValue("has_support"),false,"has_depend_fld2");
                            ?>
                        </div>
                    </div>
                </div>
            </div>
            <div class="row fld-dlversion fld-dlversion-y pt-2">
                <div class="col-sm text-center">
                    <div class="card border-warning">
                        <div class="card-body text-warning text-bold">
                            <?php $this->_e("Real client doesn't use nilled version plugin or theme, cause that contains virus, if you don't need encrypted version, then non-encrypted version is recommended.") ; ?>
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
               
                <div class="col-sm text-center p-3">
                    <button id="licenseDlButton" class="apbd-download btn btn-lg  btn-success"><i class="fa fa-download"></i> <?php $this->_e("Download"); ?></button>
                   
                </div>
            </div>
            
        </div>
    </div>
</div>
<div class="btn-group-md popup-footer ">
	<div class="clearfix">
		
		<div class="float-sm-right text-center text-sm-right ">
			
			<button type="button" class="close-pop-up btn btn-sm  btn-danger"><i class="fa fa-times"></i> <?php $this->_e("Close"); ?></button>
		</div>
		
	</div>
</div>

<script type="application/javascript">
    var licenedVersion="<?php echo $this->GetActionUrl("download",["id"=>$mainobj->id]); ?>";
    var licenedEncVersion="<?php echo $this->GetActionUrl("download",["id"=>$mainobj->id,"enc"=>"Y"]); ?>";
    jQuery( document ).ready(function( $ ) {
       $("#product_id").on("change",function(){
           ccProductChange();
       });
       $("#licenseDlButton").on("click",function (e) {
           e.preventDefault();
           var v=$("[name=dlversion]:checked").val();
            if(v=="N"){
                APPSBDAPPJS.core.DownloadURL(licenedVersion);
            }else{
                APPSBDAPPJS.core.DownloadURL(licenedEncVersion);
            }
           
       });
      /* $(".app-download").on("click",function (e) {
           e.preventDefault();
           $("<iframe>").attr("src",$(this).attr("href"));
       });*/

        <?php if(!empty($_GET['reld'])){ ?>
            APPSBDAPPJS.core.SetAjaxChangeStatus(true);
            APPSBDAPPJS.core.SetAjaxChangeEvent("<?php echo $_relaod_event; ?>");
            APPSBDAPPJS.core.CallOnCloseLightbox();
            APPSBDAPPJS.core.SetAjaxChangeStatus(false);

         <?php } ?>
      
    });
    
    function ccProductChange(){
        var v= $("#product_id").val();
        if(v !=''){
            var slug=$("#product_id option[value="+v+"]").data('slug');
            $("#slug-msg .slug-con").html(slug);
            $("#slug-msg").removeClass("d-none");
        }else{
            $("#slug-msg").addClass("d-none");
        }
    }
    <?php
    
    ?>
</script>