<?php
/** @var APBDLicenseList $this
 *  @var Mapbd_license $mainObj;
 */
?>
<div class="clearfix form pb-3">
    <div class="form-row">
        <div class="form-group col-sm">
            <label class="col-form-label" for="product_id"><?php $this->_e("Client"); ?></label>
		   
        <select data-live-search="true" data-src-type-str="<?php $this->_e("Start typing client name or email") ?>"  data-live-url="<?php echo $this->GetActionUrl("get-clients") ?>" class="app-select-picker form-control-sm " id="client_id"  name="client_id" data-bv-notempty="true" 	data-bv-notempty-message="<?php  $this->_e("%s is required",$this->__("Client"));?>">
            
			    <?php $product_client_id_selected= $mainObj->GetPostValue("client_id");
			        if(!empty($product_client_id_selected)){
				        $chclient=Mapbd_client::FindBy("id",$product_client_id_selected);
				        if($chclient) {
					        APBD_GetHTMLOption( $chclient->id, $chclient->name."({$chclient->email})", $product_client_id_selected );
				        }else{
					        APBD_GetHTMLOption( $product_client_id_selected, $this->__("Unknown"), $product_client_id_selected );
                        }
                    }
			        
			    ?>
            </select>

            <small class="form-text text-muted">
              <?php $this->_e("If you can't find your client here then please create client first %s",'<a class="popupform" href="'.(getLinkCustomButton(APBDClient::GetModuleInstance()->GetActionUrl("add"),APBD_CurrentUrl(),$this->__("Back to license form"))).'">'.$this->__("Click Here").'</a>') ; ?>
            </small>

        </div>
    </div>
    <?php
    $mainObj->GetAddForm();
    ?>

    
</div>
<div class="btn-group-md popup-footer ">
    <div class="clearfix">
      
        <div class="float-sm-right text-center text-sm-right ">
            <button type="submit" class="btn btn-sm btn-success"><i class="fa fa-save"></i> <?php echo $isUpdateMode?$this->__("Update"):$this->__("Save"); ?></button>
            <button type="button" class="close-pop-up btn btn-sm  btn-danger"><i class="fa fa-times"></i> <?php $this->_e("Cancel"); ?></button>
        </div>
        <div class="float-sm-left text-center text-sm-left">
		    <?php echo getCustomBackButtion(); ?>
        </div>
    </div>
</div>
