<?php
/** @var APBDLicenseList $this */
$grid=new jQGrid();
$grid->url =$this->GetActionUrl("data");
$grid->width = "auto";
//$grid->minWidth=500;
$grid->height = "auto";
$grid->rowNum = 20;
$grid->pager = "#pagerb";
$grid->container = "#".$this->GetModuleId()." .grid-body";
$grid->ShowReloadButtonInTitle=true;
$grid->ShowDownloadButtonInTitle=true;
$grid->isColumnChoseable=true;
$grid->DisableAutoInit();
$grid->setReloadEvent($this->GetReloadEvent());
//$grid->DisableAutoInit();
//$grid->shrinkToFit=false;

$grid->AddTitleRightHtml('<a data-effect="mfp-move-from-top" class="popupformWR btn btn-sm btn-info" href="'.$this->GetActionUrl("add").'" ><i class="fa fa-plus"></i>'.$this->__('Add New').'</a>');

//Fields
//$grid->AddModel("Id", "id", 100 ,"center");

$products=Mapbd_product::FetchAllKeyValue("id","product_name");
$grid->AddModelCustomSearchable("Product", "product_id", 100 ,"center","select",$products);
$grid->SetXSCombindeField("product_id");
$grid->AddModel("Client Name", "name", 100 ,"center");
$grid->AddSearchProperty("Client Email", "email", 100 ,"center");
$grid->AddModelCustomSearchable("License Type", "license_id", 90 ,"center","select",Mapbd_license_type::FindAllByKeyValue("status","A","id","license_title"));
//$grid->AddModelNonSearchable("Product Base Name", "product_base_name", 100 ,"center");
//$grid->AddModelNonSearchable("License Id", "license_id", 100 ,"center");
$grid->AddModel("License Key", "purchase_key", 220 ,"center");
$grid->AddModelNonSearchable("User Domain", "user_domain", 120 ,"center");
//$grid->AddModelNonSearchable("Server Ip", "server_ip", 100 ,"center");
$grid->AddModelNonSearchable("Version", "current_version", 50 ,"center");

$licenseObj=new Mapbd_license();
$markets=array_merge(["*"=>"All"],$licenseObj->GetPropertyOptionsTag( "market" ));

$grid->AddModelCustomSearchable("Market", "market", 50 ,"center","select",$markets);

//$grid->AddModelNonSearchable("Max Domain", "max_domain", 100 ,"center");
//$grid->AddModelNonSearchable("Verification Required", "verification_required", 100 ,"center");
//$grid->AddModelNonSearchable("Has Expiry", "has_expiry", 100 ,"center");

//$grid->AddModelNonSearchable("Has Support", "has_support", 100 ,"center");

$grid->AddModelCustomSearchable("Create on", "entry_time", 140 ,"center","daterange");
$grid->AddModelNonSearchable("Expire on", "expiry_time", 80 ,"center");
$grid->AddModelNonSearchable("Support Until", "support_end_time", 100 ,"center");
//$grid->AddModelNonSearchable("Request Counter", "request_counter", 100 ,"center");
//$grid->AddModelNonSearchable("Request Delay Time", "request_delay_time", 100 ,"center");
$mlic=new Mapbd_license();
;
$grid->AddModel("Extra Param", "extra_param", 100,"center");
$grid->AddModel("License Param", "lictype_param", 100,"center");
$grid->AddModelCustomSearchable("Status", "status", 70 ,"center","select",$mlic->GetPropertyRawOptions('status'));
$grid->AddModelNonSearchable("Action", "action", 100 ,"center");
$grid->addCustomHiddenFields(["current_version","lictype_param","email","expiry_time","support_end_time","market","extra_param"]);

?>
<div class="card apsbd-default-card">
    <div class="card-header"><i class="apd-mod-icon <?php echo $this->GetMenuIcon(); ?>"></i> <?php echo $this->GetMenuTitle(); ?></div>
    <div class="card-body p-3 grid-body min-height-335 " >
	    <?php $grid->show();
	    //echo $this->getHookActionStr( "response-filter" );
	    ?>
    </div>
</div>

<script type="text/javascript">
    APPSBDAPPJS.core.AddOnOnTabActive("<?php echo $this->GetModuleId() ?>",function(){
		<?php echo $grid->GetInitMethod(); ?>();
		<?php echo $grid->ResizeMethod(); ?>();
    });
    function APBD_license_list_delete(rdata){
        APPSBDAPPJS.core.CallOnReloadWithEvent("<?php echo $this->GetReloadEvent() ?>");
        APPSBDAPPJS.notification.ShowResponseSwal(rdata);
    }
</script>