<?php
	/** @var APBDLicenseList $this
	 * @var Mapbd_license $mainObj ;
	 * @var Array $domains ;
     * @var $isAppRemove;
	 */
	$mainObj = apply_filters( $this->getHookActionStr( "license-list-row-data" ), $mainObj );
	function get_td_data( $domain ) {
		ob_start()
		?>
        <td><input type="checkbox" id="check_all"></td>
        <td><?php $domain->full_domain; ?></td>
        <td>-</td>
		<?php
		return ob_get_clean();
	}

?>
<div class="clearfix form pb-3">

    <div class="card">
        <div class="card-body p-0" style="max-height: 500px; overflow: auto;">
            <table class="table table-striped m-0">
                <thead>
                    <tr>
                        <th style="width: 30px"><input type="checkbox" id="dm-check-all"></th>
                        <th><?php $this->_e( "Domain" ); ?></th>
                        <th class="text-center" style="width: 200px"><?php $this->_e( "License Remove" ); ?></th>
                        <?php if($isAppRemove){ ?>
                        <th class="text-center" style="width: 200px"><?php $this->_e( "Plugin Remove" ); ?></th>
                        <?php } ?>
                    </tr>
                </thead>
                <tbody>
               
					<?php foreach ( $domains as $key=>$domain ) {?>
                        <tr>
                            <td><input type="checkbox" class="dm-data" id="dm-<?php echo $key; ?>"  data-ud_id="<?php echo $domain->ud_id; ?>" data-user_domain="<?php echo $domain->user_domain; ?>"></td>
                            <td><label for="dm-<?php echo $key; ?>"><?php echo $domain->full_domain; ?></label></td>
                            <td class="text-center cls-rmi-status cls-info-status">-</td>
	                        <?php if($isAppRemove){ ?>
                            <td  class="text-center cls-rmi-status  cls-rm-status">-</td>
                            <?php } ?>
                        </tr>
                        <?php
					} ?>
                
                </tbody>
            </table>


        </div>
    </div>


</div>
<div class="btn-group-md popup-footer ">
    <div class="clearfix">
        <div class="float-sm-right text-center text-sm-right ">
            <a  class="popupformWR btn btn-sm btn-info" href="<?php echo esc_url(APBD_CurrentUrl()); ?>" >
                <i class="fa fa-save"></i> <?php echo $this->__( "Refresh" ); ?></a>
            <button id="process-remove-btn" type="button" class="btn btn-sm btn-success">
                <i class="fa fa-save"></i> <?php echo $this->__( "Process" ); ?></button>
            <button id="process-closed" type="button"  class="close-pop-up btn btn-sm  btn-danger"><i
                        class="fa fa-times"></i> <?php $this->_e( "Close" ); ?></button>
        </div>
        <div id="dm-msg-cener" class="float-sm-left text-center text-sm-left">
			
        </div>
    </div>
</div>
<script type="text/javascript">
  //  'use strict';
    var total_selected=0;
    var total_processed=0;
    var isClosed=false;
    
    function ProcessDomainRemoveAction(){
        if(isClosed){
            return ;
        }
        if(total_selected==0){
            $("#dm-msg-cener").html('<span class="er-msg text-danger"> <i class="fa fa-times"></i> <?php echo $this->_ee("Please select at least one domain to process"); ?></span>');
            $("#process-remove-btn").prop("disabled",false);
        }else{
            $("#dm-msg-cener").html('<span class="text-success"> <i class="fa fa-check"></i> ' + total_processed + '/' + total_selected + ' <?php echo $this->_ee( "processed" ); ?></span>');
        }
       var nextTarget=$("input.dm-data:enabled:checked").first();
       if(nextTarget.length>0){
          var tr= nextTarget.closest('tr');
           var data={
                ud_id:nextTarget.data('ud_id'),
                license_id:"<?php echo $mainObj->id; ?>",
                rm_type:"<?php echo $isAppRemove?'B':'I'; ?>",
           };
         
           
           APPSBDAPPJS.core.CallMyAjax("<?php echo $this->GetActionUrl("license-action-rm-single"); ?>",data,function(){
			   //before send

               tr.find(".cls-rmi-status").html('<div class="progress" style="height:0.5rem;">\n' +
                    '  <div class="progress-bar progress-bar-striped progress-bar-animated" role="progressbar" aria-valuenow="10" aria-valuemin="0" aria-valuemax="100" style="width: 100%"></div>\n' +
                    '</div>\n');
		   },function(rdata){
			   //success
               tr.find('.cls-info-status').addClass('status-updated').html(rdata.data.l_info);
               tr.find('.cls-rm-status').addClass('status-updated').html(rdata.data.pl_rm);
               if(rdata.status) {
                   total_processed++;
                   $("#dm-msg-cener").html('<span class="text-success"> <i class="fa fa-check"></i> ' + total_processed + '/' + total_selected + ' <?php echo $this->_ee( "processed" ); ?></span>');
               }
		   },true,function(){
               tr.find(".cls-rmi-status:not(.status-updated)").html('Try Again');
               ProcessDomainRemoveAction();
		   })
           nextTarget.prop("disabled",true);
           //ProcessDomainRemoveAction();
       }else{
           $("#process-remove-btn").prop("disabled",false);
       }
       
    }
    jQuery( document ).ready(function( $ ) {
        $("#process-remove-btn").on("click",function (e){
            e.preventDefault();
            $(this).prop("disabled",true);
            total_processed=0;
            total_selected=$("input.dm-data:enabled:checked").length;
            isClosed=false;
            ProcessDomainRemoveAction();
        });
        $("#process-closed").on("click",function (e){
            isClosed=true;
        });
        $("#dm-check-all").on("change",function(e){
            if($(this).is(":checked")){
                $("input.dm-data:enabled").prop("checked",true);
            }else{
                $("input.dm-data:enabled").prop("checked",false);
            }
        });
    });
</script>
