<?php
/** @var APBDLicenseList $this
 *  @var Mapbd_license $mainObj;
 *  @var Mapbd_domain_log [] $domains;
 */
?>

<div class="clearfix form pb-3">
    <div class="row">
        <div class="col-sm">
            <div class="card apsbd-default-card">
                <div class="card-header"><?php $this->_e("License Code"); ?> : <?php echo $mainObj->purchase_key;	?></div>
                <div class="card-body p-0 max-height-400 o-auto">

                    <table class="table m-0">
                        <thead>
                        <tr>
                            <th width="20px">#</th>
                            <th ><?php $this->_e("Domain") ?></th>
                            <th class="text-center wd-230 "><?php $this->_e("Time") ?></th>
                            <th class="text-center wd-100" ><?php $this->_e("Version") ?></th>
                            <th class="text-center wd-100" ><?php $this->_e("License Email") ?></th>
                            <th class="text-center wd-100" ><?php $this->_e("Status") ?></th>
                        </tr>
                        </thead>
                        <tbody>
		                <?php
			                $r=1;
			                foreach ( $domains as $domain ) {
				                $domain= APBD_CastClass("Mapbd_domain_log", $domain);
				                ?>
                                <tr>
                                    <td><?php echo $r++; ?></td>
                                    <td><?php echo str_replace('[Test Domain]','<span class="badge badge-success">Test Domain</span>',$domain->used_domain); ?></td>
                                    <td class="text-center" ><?php echo APBD_getWPDateTimeWithFormat($domain->entry_time); ?></td>
                                    <td class="text-center" ><?php echo $domain->version; ?></td>
                                    <td class="text-center" ><?php echo $domain->client_email; ?></td>
                                    <td  ><?php echo $domain->getTextByKey("status"); ?></td>
                                </tr>
				                <?php
			                }
		                ?>

                        </tbody>
                    </table>
                </div>
            </div>
            
          
        </div>
        

    </div>


</div>
<div class="btn-group-md popup-footer text-right">
    <button type="button" class="close-pop-up btn btn-sm  btn-danger"><i class="fa fa-times"></i> <?php $this->_e("Close"); ?></button>
</div>
