<?php
	/** @var EnvatoIntegrator $this */
?>
<div class="clearfix form pb-3">
    <div id="pro"></div>
    <div class="form-group">
        <label for="product_id"><?php $this->_e("Choose Product") ?></label>
        <select class="form-control" name="product_id" id="product_id">
            <option value=""><?php $this->_e("Select") ?></option>
           <?php
           $products=Mapbd_product::FindAllByKeyValue("status","A","id","product_name");
           $linkedProduct=$this->getLinkedProductList();
	           foreach ( $products as $key=>$product ) {
	               if(isset($linkedProduct[$key])){
	                   continue;
                   }
		           APBD_GetHTMLOption($key,$product,APBD_PostValue("product_id"));
	           }
         
           ?>
        </select>
    </div>
    <div class="form-group">
        <label for="exampleFormControlSelect2"><?php $this->_e("Choose Envato Site") ?></label>
        <select  class="form-control"  id="site">
            <option value=""><?php $this->_e("Select") ?></option>
            <option value="codecanyon">CodeCanyon.com</option>
            <option value="themeforest">themeforest.net</option>
        </select>
    </div>
    <div class="form-group">
        <label for="env_product_id"><?php $this->_e("Choose Product") ?></label>
        <select class="form-control" name="env_product_id" id="env_product_id">
            <option value=""><?php $this->_e("Select") ?></option>
        </select>
    </div>
</div>
<div class="btn-group-md popup-footer text-right">
    <button type="submit" class="btn btn-sm btn-success"><i class="fa fa-save"></i> <?php echo !empty($isUpdateMode)?$this->__("Update"):$this->__("Save"); ?></button>
    <button type="button" class="close-pop-up btn btn-sm  btn-danger"><i class="fa fa-times"></i> <?php $this->_e("Cancel"); ?></button>
</div>
<script type="application/javascript">
    var loadedProduct=[];
    jQuery( document ).ready(function( $ ) {
        $("#site").on("change",function (e) {
            LoadEnvatoProduct();
        });
    });
    function LoadEnvatoProduct(){
        var st=$("#site").val();
        if(st.length==0){
            return;
        }
        if(typeof loadedProduct[st] !="undefined"){
            envato_process_response(loadedProduct[st]);
            return;
        }
        $.ajax({
            type: "POST",
            url: "<?php echo  $this->GetActionUrl("get-envato-products");?>",
            data: {s:st},
            dataType: 'json',
            beforeSend:function(){
                APPSBDAPPJS.notification.ShowWaitinglight(true,null,"<?php $this->_e("Loading %s Products","Envato"); ?>");
            },
            success: function(rdata){
                loadedProduct[st]=rdata;
                envato_process_response(rdata);
                
            },
            complete:function(){
                APPSBDAPPJS.notification.ShowWaitinglight(false);
            }

        });
    }
    function envato_process_response(rdata){
        var targetSelect=$("#env_product_id");
        targetSelect.find("option[data-evp]").remove();
        $.each(rdata,function(env_id,val){
            targetSelect.append('<option data-evp="" value="'+env_id+'">'+val+'</option>');
        });
    }
</script>