<?php
	/** @var APBDLicenseList $this
	 *  @var Mapbd_product $product;
	 *  @var APBDScriptGeneratorBase $generator;
	 */
	
?>
<div class="clearfix form p-3">
    <div class="card app-card-default">
        <div class="card-header bg-white text-bold">
			<?php $this->_e("Download License Script") ; ?>
        </div>
        <div class="card-body p-0">
           <table class="table m-0">
               <tr>
                   <th width="25%"><?php $this->_e("Product Name") ; ?></th>
                   <td width="10%">:</td>
                   <td width="65%"><?php echo $product->product_name; ?></td>
               </tr>
               <tr>
                   <th><?php $this->_e("Product Base Name") ; ?></th>
                   <td>:</td>
                   <td><?php echo $product->product_base; ?></td>
               </tr>
               <tr>
                   <th><?php $this->_e("Product Status") ; ?></th>
                   <td>:</td>
                   <td><?php echo $product->getTextByKey("status"); ?></td>
               </tr>
               <tr>
                   <th><?php $this->_e("Generator Type") ; ?></th>
                   <td>:</td>
                   <td><i class="<?php echo $generator->icon; ?>"></i> <?php echo $generator->name; ?></td>
               </tr>
               <tr>
                   
                   <td colspan="3" class="text-center">
                       <?php if(!$this->kernelObject->isDemoMode()){ ?>
                       <a target="_blank" href="<?php  echo $this->GetActionUrl("process-script",["p"=>$product->id,"gt"=>$gntype]) ?>" 
                          class="btn btn-lg btn-success">
                           <i class="fa fa-download"></i>
                           <?php $this->_e("Download Script") ; ?>
                       </a>
                       <?php }else{
                           ?>
                           <h4 class="text-danger">License Script Generation has been disabled in Demo Mode</h4>
	                       <?php
                       } ?>
                   </td>
                 
               </tr>
               
           </table>
        </div>
        
    </div>
    
</div>
<div class="btn-group-md popup-footer ">
	<div class="clearfix">
        
        <div class="float-sm-right text-center text-sm-right ">
			<button type="button" class="close-pop-up btn btn-sm  btn-danger"><i class="fa fa-times"></i> <?php $this->_e("Close"); ?></button>
		</div>
		<div class="float-sm-left text-center text-sm-left">
			<?php echo getCustomBackButtion(); ?>
		</div>
	</div>
</div>
