<?php
	/** @var APBDLicenseList $this
	 *  @var Mapbd_product $mainObj;
	 */
?>
<div class="clearfix form pb-3">
   
            <div class="form-group row">
                <label class="col-sm-5 col-form-label text-right pt-0" for="product_name"><?php $this->_ee("Choose Generation Type"); ?></label>
                <div class="col-sm-7">
                <?php
                    $scriptGenerators=Mapbd_product::getScriptGenerators();
                    foreach ( $scriptGenerators as $k_id=>$script_generator ) {
                        ?>
                        <div class="md-radio mb-2">
                            <input class=""
                                   id="gen_<?php echo $k_id; ?>" type="radio"
                                   name="genType" value="<?php echo $k_id; ?>"
                                   data-bv-notempty="true"
                                   <?php echo APBD_PostValue("genType")==$k_id?" checked ":""; ?>
                                   data-bv-notempty-message="<?php $this->_e( "Choose type" ); ?>"
	                            <?php if(!$script_generator->isActive){
		                            ?>
                                   disabled
		                            <?php
	                            } ?>
                            />
                            <label class="" for="gen_<?php echo $k_id; ?>">
                                <i class="<?php echo $script_generator->icon; ?>"></i>
                                <?php echo $script_generator->name; ?>
                            </label>
                        </div>
                        <?php
                    }
                ?>
               
                </div>
            </div>
   
</div>
<div class="btn-group-md popup-footer ">
	<div class="clearfix">
		
		<div class="float-sm-right text-center text-sm-right ">
			<button type="submit" class="btn btn-sm btn-success"><?php $this->_e("Next"); ?> <i class="fa fa-angle-double-right"></i> </button>
			<button type="button" class="close-pop-up btn btn-sm  btn-danger"><i class="fa fa-times"></i> <?php $this->_e("Cancel"); ?></button>
		</div>
		<div class="float-sm-left text-center text-sm-left">
			<?php echo getCustomBackButtion(); ?>
		</div>
	</div>
</div>
