<?php 
		/** @var AppsBDBaseModule $this */
$grid=new jQGrid();
$grid->url =$this->GetActionUrl("data");;
$grid->width = "auto";
//$grid->minWidth=500;
$grid->height = "auto";
$grid->rowNum = 20;
$grid->pager = "#pagerb";
$grid->container = "#".$this->GetModuleId()." .grid-body";;
$grid->ShowReloadButtonInTitle=true;
$grid->ShowDownloadButtonInTitle=true;
$grid->DisableAutoInit();
//$grid->shrinkToFit=false;
$grid->AddTitleRightHtml('<a data-effect="mfp-move-from-top" class="popupformWR btn btn-xs btn-info" href="'.$this->GetActionUrl("add").'" ><i class="fa fa-plus"></i>'.$this->__('Add New').'</a>');

//Fields
//$grid->AddModel("Id", "id", 100 ,"center");
$grid->AddModelNonSearchable("Title", "title", 100 ,"center");
$grid->SetXSCombindeField("title");
//$grid->AddModelNonSearchable("Url", "url", 100 ,"center");
$grid->AddModelNonSearchable("Private Key", "private_key", 100 ,"center");
$grid->AddModelNonSearchable("On New Client", "is_on_client", 100 ,"center");
$grid->AddModelNonSearchable("On New License", "is_on_license", 100 ,"center");
$grid->AddModelNonSearchable("Status", "status", 100 ,"center");
$grid->AddModelNonSearchable("Action", "action", 100 ,"center");

?>
<div class="card apsbd-default-card">
    <div class="card-header">
        <div class="row">
            <div class="col-sm-3">
                <i class="app-mod-icon <?php echo $this->GetMenuIcon(); ?>"></i> <?php echo $this->GetMenuTitle(); ?>
            </div>
            <div class="col-sm">
                <div class="input-group input-group-sm">
                    <div class="input-group-prepend">
                        <span class="input-group-text"><?php $this->_e("Send On Client Test Request") ; ?></span>
                    </div>
                    <select  id="send_test_client"  class="custom-select">
				        <?php
					        $testClients=Mapbd_client::FindAllBy("status","A",[],"id","desc",10,0);
					        foreach ($testClients as $testClient){
						        APBD_GetHTMLOption($testClient->id,$testClient->name);
					        }
				        ?>
                    </select>
                    <div class="input-group-append">
                        <button class="btn btn-secondary" type="button" id="sendTestClientBtn"><?php $this->_e("Send") ; ?></button>
                    </div>
                </div>

            </div>
            <div class="col-sm">
                <div class="input-group input-group-sm">
                    <div class="input-group-prepend">
                        <span class="input-group-text"><?php $this->_e("Send on License Test Request") ; ?></span>
                    </div>
                    <select  id="send_test_license"  class="custom-select">
				        <?php
                            $mlobj=new Mapbd_license();
                            $mlobj->status("in ('A','W')",true);
                            $mclient=new Mapbd_client();
                            $mlobj->Join($mclient,"id","client_id");
					        $testClients=$mlobj->SelectAll("id,purchase_key,".$mclient->GetTableName().".name as client_name","id","desc",10,0);
					        foreach ($testClients as $testClient){
						        APBD_GetHTMLOption($testClient->id,APBD_GetLastFirstSubString($testClient-> purchase_key,7,'&bull;',5)." ($testClient->client_name)");
					        }
				        ?>
                    </select>
                    <div class="input-group-append">
                        <button class="btn btn-secondary" type="button" id="sendTestLicneseBtn"><?php $this->_e("Send") ; ?></button>
                    </div>
                </div>

            </div>
        </div>
        
    </div>
    <div class="card-body p-3 grid-body" style="min-height: 335px;">
	    <?php $grid->show();?>
    </div>
</div>
<script type="text/javascript">
 APPSBDAPPJS.core.AddOnOnTabActive("<?php echo $this->GetModuleId() ?>",function(){
	 <?php echo $grid->GetInitMethod(); ?>();
	 <?php echo $grid->ResizeMethod(); ?>();
 });
     jQuery( document ).ready(function( $ ) {
         $("#sendTestLicneseBtn").on("click",function(e){
             e.preventDefault();
             var thisObj=$(this);
             var vald=$("#send_test_license").val();
             $.ajax({
                 url: "<?php echo APBDLicenseSettings::GetModuleInstance()->GetActionUrl("send-test-hook"); ?>",
                 data:{param:vald,type:"lic"},
                 dataType: 'json',
                 type:"POST",
                 beforeSend:function(){
                     //$("#linkedProductCard .div-loader").show();
                     thisObj.data("predata",thisObj.html());
                     thisObj.html('<i class="fa fa-spinner fa-spin"></i>');
                 },
                 success: function (rdata) {
                     // $("#linked-product-container").html(rhtml);
                     APPSBDAPPJS.notification.ShowGritterMsg(rdata.msg, rdata.status, rdata.is_sticky, rdata.title, rdata.icon);
                 },
                 complete:function(){
                     thisObj.html(thisObj.data("predata"));
                 }

             });

         });
         $("#sendTestClientBtn").on("click",function(e){
             e.preventDefault();
             var thisObj=$(this);
             var vald=$("#send_test_client").val();
             $.ajax({
                 url: "<?php echo APBDLicenseSettings::GetModuleInstance()->GetActionUrl("send-test-hook"); ?>",
                 data:{param:vald,type:"cl"},
                 dataType: 'json',
                 type:"POST",
                 beforeSend:function(){
                     //$("#linkedProductCard .div-loader").show();
                     thisObj.data("predata",thisObj.html());
                     thisObj.html('<i class="fa fa-spinner fa-spin"></i>');
                 },
                 success: function (rdata) {
                     // $("#linked-product-container").html(rhtml);
                     APPSBDAPPJS.notification.ShowGritterMsg(rdata.msg, rdata.status, rdata.is_sticky, rdata.title, rdata.icon);
                 },
                 complete:function(){
                     thisObj.html(thisObj.data("predata"));
                 }

             });
         });

     });

</script>
